const node_push = require("node-pushnotifications");

let notification = {
    /**
     * notification configuration
     */
    setting: {
        gcm: {
            id: 'AAAA4GN6J3k:APA91bGtEliW56f57L7o9JmM3oSh_eiIv1C64dFiKTF8QFgDlIYFrGeWA49Xj00al75VvcO-ZMYvk5nqScM2EwtykNupIcIqDwB4VdjzSHuILOiMjxSV-cDdTwfCtcPJIZCM9fC5Z9Kt',
        },
        apn: {
            token: {
                key: './Certificates/AuthKey_6A2N2WXR55.p8',
                keyId: '6A2N2WXR55',
                teamId: '5Q4NVFPC8B',
            },
            production: false
        }
    },
    /**
     * This function is used to send notification
     */
    sendPush: (device_id, message, callback) => {
        let topic = (message.device_type == "A" || message.device_type == "W") ? "com.neshwa" : "com.neshwa.app";
        let alertData = {
            title: message.title,
            body: message.message,
            tag: message.tag,
            image_url: message.image_url,
            message_string: message.message,
            title_string: message.title,
        }
        let customData = {
            title: message.title,
            body: message.message,
            tag: message.tag,
            image_url: message.image_url,
            message_string: message.message,
            title_string: message.title,
        }

        if (message.post_id != undefined && message.post_id != '') {
            alertData.post_id = message.post_id;
            customData.post_id = message.post_id;
        }
        if (message.comment_id != undefined && message.comment_id != '') {
            alertData.comment_id = message.comment_id;
            customData.comment_id = message.comment_id;
        }
        if (message.follow_id != undefined && message.follow_id != '') {
            alertData.follow_id = message.follow_id;
            customData.follow_id = message.follow_id;
        }


        if (message.reel_id != undefined && message.reel_id != '') {
            alertData.reel_id = message.reel_id;
            customData.reel_id = message.reel_id;
        }


        if (message.like_id != undefined && message.like_id != '') {
            alertData.like_id = message.like_id;
            customData.like_id = message.like_id;
        }
        if (message.collaborate_id != undefined && message.collaborate_id != '') {
            alertData.collaborate_id = message.collaborate_id;
            customData.collaborate_id = message.collaborate_id;
        }
        if (message.goal_id != undefined && message.goal_id != '') {
            alertData.goal_id = message.goal_id;
            customData.goal_id = message.goal_id;
        }
        if (message.goal_request_id != undefined && message.goal_request_id != '') {
            alertData.goal_request_id = message.goal_request_id;
            customData.goal_request_id = message.goal_request_id;
        }
        let pushPayload = {
            topic: topic,
            alert: alertData,
            sound: "default",
            custom: customData,
            android: {
                priority: 'high'
            }
        }
        if (message.device_type == "A") {
            delete pushPayload.sound;
        }
        let push = new node_push(this.setting);

        push.send(device_id, pushPayload, (error, result) => {
            console.log('error', error);
            console.log('result', result);
            if (error) {
                callback(false);
            } else {
                callback(true);
            }
        });
    },
};

module.exports = notification;
