
let con = require("../config/database");

let no_data_msg = 'data_not_found';
let failed_msg = "something_went";

let SQLWorker = {
    //////////////////////////////////////////////////////////////////////
    //                           DB  Workers                            //
    //////////////////////////////////////////////////////////////////////

    SELECT: (query, type, no_data_err = true) => {
        return new Promise((resolve, reject) => {
            con.query(query, (err, result) => {
                // console.log(err)
                if (!err) {
                    // console.log(result)
                    if (result.length > 0) {
                        if (type == "Single") {
                            resolve(result[0]);
                        } else {
                            resolve(result);
                        }
                    } else {
                        if (no_data_err) {
                            reject(no_data_msg);
                        } else {
                            resolve([]);
                        }
                    }
                } else {
                    reject(failed_msg);
                }
            });
        });
    },

    UPDATE: (query, data) => {
        return new Promise((resolve, reject) => {
            con.query(query, data, (err, result) => {
                console.log('err :', err);
                if (!err) {
                    resolve();
                } else {
                    reject(failed_msg);
                }
            });
        });
    },

    INSERT: (query, data, failed_msg_param = failed_msg) => {
        return new Promise((resolve, reject) => {
            try {
                con.query(query, data, (err, result) => {
                    console.log('err :', err);
                    if (!err) {
                        resolve(result.insertId);
                    } else {
                        reject(failed_msg_param);
                    }
                });
            }
            catch (e) {
                console.log('e :', e);

            }

        });
    },

    DELETE: (query) => {
        return new Promise((resolve, reject) => {
            con.query(query, (err, result) => {
                if (!err) {
                    resolve();
                } else {
                    reject(failed_msg);
                }
            });
        });
    },
};
module.exports = SQLWorker;