const { default: localizify } = require('localizify');
const {
    t
} = require('localizify');
let httpStatusCode = require("http-status-codes");
let config = require("../config/config");
let constant = require("../config/constant");
let database = require("../config/database");
let userModel = require('../model/user');
let userDeviceInfoModel = require('../model/user_device_info');
let lodash = require("lodash");
let cryptLib = require('cryptlib');
let en = require("../language/en");
const responseCode = require("../config/response-error-code");
let common = require('../utilities/common')
let CryptoJS = require("crypto-js");
let AES = require("crypto-js/aes");
let Flatted = require('flatted');
let validate_header = {

    /* function to encryptionPlain */
    encryptionPlain: (data) => {
        // let encryptedText = CryptoJS.AES.encrypt(JSON.stringify(data), constant.cryptKey).toString();
        encryptedText = cryptLib.encrypt(JSON.stringify(data), constant.cryptKey, constant.cryptIV);
        return encryptedText;
    },

    /* function to encryption */
    encryption: (data) => {
        // let encryptedText = CryptoJS.AES.encrypt(JSON.stringify(data), constant.cryptKey).toString();
        let encryptedText = cryptLib.encrypt(data, constant.cryptKey, constant.cryptIV);
        return encryptedText;
    },
    /* function to decryption  */
    dcryption: (data) => {
        // let bytes = CryptoJS.AES.decrypt(data, constant.cryptKey);
        // let decryptedData = bytes.toString(CryptoJS.enc.Utf8);
        let decryptedData = cryptLib.decrypt(data, constant.cryptKey, constant.cryptIV);
        return decryptedData;
    },
    /* function to dedcrypt Body */
    decryptBody: (req, res, next) => {
        if (req.body != undefined && req.body != "" && !validate_header.isEmpty(req.body)) {
            try {
                o = JSON.parse(validate_header.dcryption(req.body));
                // console.log("req.body", o)
                // o = JSON.parse(req.body);
                if (o && typeof o === "object") {
                    req.body = o;
                    // console.log("req.body", req.body)
                }
            } catch (e) {
                // console.log("req.body", e)
                validate_header.send_response(res, { code: "0", message: t('bodyIncorrect') });
            }
        } else {
            req.body = {};
        }
        next();
    },
    // this function is used to send response
    send_response: (res, response_data, status_code = httpStatusCode.OK) => {
        res.status(status_code);
        console.log("response_data", response_data)
        // res.json(validate_header.encryptionPlain(response_data));
        res.json(response_data);
    },
    /* function to check object is empty or not */
    isEmpty: (obj) => {
        return Object.keys(obj).length === 0;
    },
    /* function is use to check valid json data or not */
    checkJsonDataValid: (res, data) => {
        if (data != undefined && data != "") {
            try {
                o = JSON.parse(validate_header.dcryption(data));
                if (o && typeof o === "object") {
                    data = o;
                }
            } catch (e) {
                validate_header.send_response(res, { code: "0", message: t('invalid_data') });
            }
        } else {
            data = {};
        }
    },
    /* check encrypted data is right or not */
    checkDataValid: (res, data) => {
        if (data != undefined && data != "") {
            try {
                o = validate_header.dcryption(data);
                if (o && typeof o === "string") {
                    data = o;
                }
            } catch (e) {
                validate_header.send_response(res, { code: "0", message: t('headerIncorrect') }, httpStatusCode.UNAUTHORIZED);
            }
        } else {
            data = "";
        }
        return data;
    },
    /* Token Validate */
    validateToken: (req, res, next) => {
        let headers = req.headers;
        // let supported_languages = ['en'];
        let supported_languages = ['en'];
        let lng = 'en';
        if (req.headers.accept_language !== undefined && req.headers.accept_language != "" && supported_languages.indexOf(req.headers.accept_language) != -1) {
            let lng = req.headers.accept_language;
        }
        // console.log("lng", lng)
        // constant.language = lng;
        localizify
            .add('en', en)
            .setLocale(lng);
            // console.log(headers.api_key)
            // console.log(constant.api_key)
        if (lodash.isEqual(headers.api_key, constant.api_key)) {

            req = validate_header.extractMethod(req);

            /**
             * Get bool value whether the method is bypass or not
             */
            let isByPass = (constant.byPasMethodsUser.find((element) => {
                return (lodash.isEqual(req.requestMethod, element)) ? true : false;
            }) == req.requestMethod) ? true : false;

            if (isByPass) {
                next();
            } else {

                /**
                 * Condition is used to check whether authorization token is comming or not
                 */
                if (headers.token != undefined && headers.token != "") {
                    let barearToken = headers.token;
                    // let barearToken = validate_header.dcryption(headers.token);
                    console.log("barearToken", barearToken)
                    if (barearToken == constant.by_pass_token) {
                        next();
                    } else {
                        if (barearToken) {
                            let data = {
                                access_token: barearToken,
                                app: req.headers.app
                            }

                            validate_header.getRequestOwner(data, (_getRequestOwnerError, _owner) => {

                                if (_getRequestOwnerError) {
                                    let message = {
                                        code: responseCode.OPERATION_FAILED,
                                        message: _getRequestOwnerError
                                    }
                                    validate_header.send_response(res, message, httpStatusCode.UNAUTHORIZED);
                                } else {
                                    if (_owner.status == "Active") {
                                        req.login_user = _owner;
                                        req.login_user_device_type = _owner.device_type;
                                        req.login_user_id = _owner._id;
                                        // console.log("object already")
                                        next();
                                    } else {
                                        let message = {
                                            code: responseCode.OPERATION_FAILED,
                                            message: t("account_is_deactivated")
                                        }
                                        validate_header.send_response(res, message, httpStatusCode.UNAUTHORIZED);
                                    }
                                }
                            })

                        } else {
                            let message = {
                                code: responseCode.OPERATION_FAILED,
                                message: t("header_authorization_format_error")
                            }
                            validate_header.send_response(res, message, httpStatusCode.UNAUTHORIZED);
                        }
                    }

                } else {
                    let message = {
                        code: responseCode.OPERATION_FAILED,
                        message: t("header_authorization_key")
                    }
                    validate_header.send_response(res, message, httpStatusCode.UNAUTHORIZED);
                }
            }
        } else {

            let message = {
                code: responseCode.OPERATION_FAILED,
                message: t("header_key_value_incorrect")
            }
            validate_header.send_response(res, message, httpStatusCode.UNAUTHORIZED);
        }
    },
    /**
    * @param {Object} req incomming request object
    * 
    * This function is used to get user information based on incoming request
    */
    getRequestOwner: (_token, callback) => {
        userModel.aggregate([
            {
                $lookup: {
                    from: 'user_device_infos',     //collection name
                    localField: '_id',
                    foreignField: 'user_id',
                    as: 'userDeviceData'     //alias
                }
            },
            {
                $unwind: '$userDeviceData' // Deconstructs the array of joined documents into separate documents
            },
            {
                $match: {
                    'userDeviceData.token': _token.access_token,
                }
            },
            {
                $project: {
                    username: 1,
                    nickname: 1,
                    first_name: 1,
                    last_name: 1,
                    dob: 1,
                    email: 1,
                    country_code: 1,
                    phone: 1,
                    is_biomatric_enable: 1,
                    zip_code: 1,
                    gender: 1,
                    blood_type: 1,
                    profile_type: 1,
                    status: 1,
                    is_verify: 1,
                    personality_type: 1,
                    secondary_email: 1,
                    other_gender: 1,
                    add_other_gender: 1,
                    token: '$userDeviceData.token', // Select specific field (name) from the joined user data
                    device_type: '$userDeviceData.device_type' // Select specific field (name) from the joined user data
                }
            }
        ]).then(result => {
            // console.log("result", result)
            callback(undefined, result[0]);
        }).catch((err) => {
            callback(t("invalid_access_token"), undefined);
        })
    },
    /**
  * @param {req} Object Incoming request object
  * 
  * @description This function is used to extract calling information from the url
  */
    extractMethod: (request) => {
        let url = request.originalUrl;
        let segment = [];
        url.split("/").forEach((element) => {
            if (!lodash.isEmpty(element)) {
                segment.push(element.trim());
            }
        });
        request.appVersion = segment[0];
        request.requestedModule = segment[1];
        request.requestMethod = segment[(segment.length) - 1];
        return request;
    },
    /* to generate random string */
    randomTokenString(length = 20) {
        //edit the token allowed characters
        let a = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1233+year_data567890".split("");
        let b = [];
        for (let i = 0; i < length; i++) {
            let j = (Math.random() * (a.length - 1)).toFixed(0);
            b[i] = a[j];
        }
        return b.join("");
    },
}

module.exports = validate_header