const mongoose = require('mongoose');
const Schema = mongoose.Schema;
const chatRoomModel = new Schema({
    user_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    type: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    relationship_id: { type: mongoose.Schema.Types.ObjectId, ref: 'relationships' },
    is_sa: { type: String, enum: ["1", "0"], default: '0', },
    is_delete: { type: String, enum: ["1", "0"], default: '0', },
},
    { timestamps: true }
);
chatRoomModel.plugin(AutoIncrement, { id: 'chat_rooms', inc_field: 'id' });
module.exports = mongoose.model('chat_rooms', chatRoomModel);