const mongoose = require('mongoose');
const AutoIncrement = require('mongoose-sequence')(mongoose);
const Schema = mongoose.Schema;
const models = mongoose.models;
const familyModel = new Schema({
    user_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    family_member_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    relationship_id: { type: mongoose.Schema.Types.ObjectId, ref: 'relationships' },
    is_delete: { type: String, enum: ["1", "0"], default: '0', },
},
    { timestamps: true }
);
familyModel.plugin(AutoIncrement, { id: 'family', inc_field: 'id' });
module.exports = mongoose.model('family', familyModel);