const mongoose = require('mongoose');
const AutoIncrement = require('mongoose-sequence')(mongoose);
const Schema = mongoose.Schema;
const models = mongoose.models;
const foldersModel = new Schema({
    user_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    name: { type: String, default: '' },
    is_active: { type: String, enum: [0, 1], default: 1 },
    is_delete: { type: String, enum: [0, 1], default: 0 },
    is_default: { type: String, enum: ["0", "1"], default: "0" },
},
    { timestamps: true }
);
foldersModel.plugin(AutoIncrement, { id: 'folders', inc_field: 'id' });
module.exports = mongoose.model('folders', foldersModel);