const mongoose = require('mongoose');
const AutoIncrement = require('mongoose-sequence')(mongoose);
const Schema = mongoose.Schema;
const models = mongoose.models;
const followersModel = new Schema({
    follower_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    following_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    status: { type: String, enum: ["Pending", "Accept", "Reject"], default: "Pending" },
    is_delete: { type: String, enum: [0, 1], default: 0 },
},
    { timestamps: true }
);
followersModel.plugin(AutoIncrement, { id: 'followers', inc_field: 'id' });
module.exports = mongoose.model('followers', followersModel);