const mongoose = require('mongoose');
const AutoIncrement = require('mongoose-sequence')(mongoose);
const Schema = mongoose.Schema;
const models = mongoose.models;
const goalCatoriesModel = new Schema({
    user_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    name: { type: String, required: true },
    image: { type: String, default: '' },
    is_delete: { type: String, enum: ["0", "1"], default: "0" },
},
    { timestamps: true }
);
goalCatoriesModel.plugin(AutoIncrement, { id: 'goal_categories', inc_field: 'id' });
module.exports = mongoose.model('goal_categories', goalCatoriesModel);