const mongoose = require('mongoose');
const AutoIncrement = require('mongoose-sequence')(mongoose);
const Schema = mongoose.Schema;
const models = mongoose.models;
const goalsRequestModel = new Schema({
    user_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    goal_id: { type: mongoose.Schema.Types.ObjectId, ref: 'goals_and_dreams' },
    request_user_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    status: { type: String, enum: ["Pending", "Accept", "Reject"], default: "Pending" },
},
    { timestamps: true }
);
goalsRequestModel.plugin(AutoIncrement, { id: 'goal_request', inc_field: 'id' });
module.exports = mongoose.model('goal_request', goalsRequestModel);