const mongoose = require('mongoose');
const AutoIncrement = require('mongoose-sequence')(mongoose);
const Schema = mongoose.Schema;
const models = mongoose.models;
const goalsAndDreamsModel = new Schema({
    user_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    index_number: { type: String, default: '0' },
    goal_title: { type: String, required: true },
    goal_description: { type: String, default: '' },
    goal_type: { type: String, required: true },
    start_date: { type: Date, required: true },
    end_date: { type: Date, required: true },
    music: { type: String, default: '' },
    privacy: { type: String, default: 'Public' },
    goal_category_id: { type: mongoose.Schema.Types.ObjectId, ref: 'goal_categories' },
    share_with_all: { type: String, enum: ["0", "1"], default: "0" },
    is_reminder: { type: String, enum: ["0", "1"], default: "0" },
    addToCalender: { type: String, enum: ["0", "1"], default: "0" },
    is_delete: { type: String, enum: ["0", "1"], default: "0" },
},
    { timestamps: true }
);
goalsAndDreamsModel.plugin(AutoIncrement, { id: 'goals_and_dreams', inc_field: 'id' });
module.exports = mongoose.model('goals_and_dreams', goalsAndDreamsModel);