const mongoose = require('mongoose');
const AutoIncrement = require('mongoose-sequence')(mongoose);
const Schema = mongoose.Schema;
const models = mongoose.models;
const notificationsModel = new Schema({
    sender_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    receiver_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    receiver_type: { type: String, default: '' },
    sender_type: { type: String, default: '' },
    notification_tag: { type: String, default: '' },
    image: { type: String, default: '' },
    title: { type: String, default: '' },
    message: { type: String, default: '' },
    post_id: { type: mongoose.Schema.Types.ObjectId, ref: 'posts' },
    comment_id: { type: mongoose.Schema.Types.ObjectId, ref: 'post_comments' },
    like_id: { type: mongoose.Schema.Types.ObjectId, ref: 'post_likes' },
    reel_id: { type: mongoose.Schema.Types.ObjectId, ref: 'reels' },
    follow_id: { type: mongoose.Schema.Types.ObjectId, ref: 'followers' },
    collaborate_id: { type: mongoose.Schema.Types.ObjectId, ref: 'post_collaborator_users' },
    goal_id: { type: mongoose.Schema.Types.ObjectId, ref: 'goals_and_dreams' },
    goal_request_id: { type: mongoose.Schema.Types.ObjectId, ref: 'goal_requests' },
    is_read: { type: String, enum: ["0", "1"], default: "0" },
    is_delete: { type: String, enum: ["0", "1"], default: "0" },
},
    { timestamps: true }
);
notificationsModel.plugin(AutoIncrement, { id: 'notifications', inc_field: 'id' });
module.exports = mongoose.model('notifications', notificationsModel);