const mongoose = require('mongoose');
const AutoIncrement = require('mongoose-sequence')(mongoose);
const Schema = mongoose.Schema;
const models = mongoose.models;
const postCategoryModel = new Schema({
    user_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    post_id: { type: mongoose.Schema.Types.ObjectId, ref: 'posts' },
    category_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
},
    { timestamps: true }
);
postCategoryModel.plugin(AutoIncrement, { id: 'post_categories', inc_field: 'id' });
module.exports = mongoose.model('post_categories', postCategoryModel);