const mongoose = require('mongoose');
const AutoIncrement = require('mongoose-sequence')(mongoose);
const Schema = mongoose.Schema;
const models = mongoose.models;
const postCollaboratorsUsersModel = new Schema({
    user_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    post_id: { type: mongoose.Schema.Types.ObjectId, ref: 'posts' },
    collaborator_user_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    status: { type: String, enum: ['Pending', 'Accept', 'Reject'], default: 'Pending' }
},
    { timestamps: true }
);
postCollaboratorsUsersModel.plugin(AutoIncrement, { id: 'post_collaborator_users', inc_field: 'id' });
module.exports = mongoose.model('post_collaborator_users', postCollaboratorsUsersModel);