const mongoose = require('mongoose');
const AutoIncrement = require('mongoose-sequence')(mongoose);
const Schema = mongoose.Schema;
const models = mongoose.models;
const postCommentsModel = new Schema({
    user_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    post_id: { type: mongoose.Schema.Types.ObjectId, ref: 'posts' },
    message: { type: String },
    parentComment: { type: mongoose.Schema.Types.ObjectId, ref: 'post_comments' }
},
    { timestamps: true }
);
postCommentsModel.plugin(AutoIncrement, { id: 'post_comments', inc_field: 'id' });
module.exports = mongoose.model('post_comments', postCommentsModel);