const mongoose = require('mongoose');
const AutoIncrement = require('mongoose-sequence')(mongoose);
const Schema = mongoose.Schema;
const models = mongoose.models;
const postHashtagModel = new Schema({
    user_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    post_id: { type: mongoose.Schema.Types.ObjectId, ref: 'posts' },
    type: { type: String, enum: ['Post', 'Story'], default: 'Post' },
    hashtag_id: { type: mongoose.Schema.Types.ObjectId, ref: 'hashtags' },
    is_active: { type: String, enum: ["0", "1"], default: "1" },
    is_delete: { type: String, enum: ["0", "1"], default: "0" },
},
    { timestamps: true }
);
postHashtagModel.plugin(AutoIncrement, { id: 'post_hatshtags', inc_field: 'id' });
module.exports = mongoose.model('post_hatshtags', postHashtagModel);