const mongoose = require('mongoose');
const AutoIncrement = require('mongoose-sequence')(mongoose);
const Schema = mongoose.Schema;
const models = mongoose.models;
const postMediaModel = new Schema({
    user_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    post_id: { type: mongoose.Schema.Types.ObjectId, ref: 'posts' },
    type: { type: String, enum: ['image', 'video', 'audio'], default: 'image' },
    index_number: { type: Number, default: 0 },
    media_url: { type: String, default: '' },
    thumb_image: { type: String, default: '' },
},
    { timestamps: true }
);
postMediaModel.plugin(AutoIncrement, { id: 'post_media', inc_field: 'id' });
module.exports = mongoose.model('post_media', postMediaModel);