const mongoose = require('mongoose');
const AutoIncrement = require('mongoose-sequence')(mongoose);
const Schema = mongoose.Schema;
const models = mongoose.models;
const postReportModel = new Schema({
    user_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    post_id: { type: mongoose.Schema.Types.ObjectId, ref: 'posts' },
    reason_id: { type: mongoose.Schema.Types.ObjectId, ref: 'report_reasons' },
    description: { type: String, default: '' }
},
    { timestamps: true }
);
postReportModel.plugin(AutoIncrement, { id: 'post_report', inc_field: 'id' });
module.exports = mongoose.model('post_report', postReportModel);