const mongoose = require('mongoose');
const AutoIncrement = require('mongoose-sequence')(mongoose);
const Schema = mongoose.Schema;
const models = mongoose.models;
const postTagUsersModel = new Schema({
    user_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    post_id: { type: mongoose.Schema.Types.ObjectId, ref: 'posts' },
    tag_user_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
},
    { timestamps: true }
);
postTagUsersModel.plugin(AutoIncrement, { id: 'post_tag_users', inc_field: 'id' });
module.exports = mongoose.model('post_tag_users', postTagUsersModel);