const mongoose = require('mongoose');
const AutoIncrement = require('mongoose-sequence')(mongoose);
const Schema = mongoose.Schema;
const models = mongoose.models;
const postsModel = new Schema({
    user_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    type: { type: String, enum: ['text', 'image', 'voice', 'video', 'music'], default: 'text' },
    folder_id: { type: mongoose.Schema.Types.ObjectId, ref: 'folders' },
    profile_id: { type: mongoose.Schema.Types.ObjectId, ref: 'postProfiles' },
    message: { type: String, default: '' },
    location: { type: String, default: '' },
    location_latitude: { type: String, default: '' },
    location_longitude: { type: String, default: '' },
    location_full_address: { type: String, default: '' },
    color_name: { type: String, default: '' },
    color_id: { type: mongoose.Schema.Types.ObjectId, ref: 'background_color' },
    is_color_background: { type: Boolean, enum: [true, false], default: false },
    description: { type: String, default: '' },
    image: { type: String, default: '' },
    music: { type: String, default: '' },
    privacy: { type: String, default: 'Public' },
    viewCount: { type: Number, default: 0 },
    status: { type: String, enum: ['Public', 'Private'], default: 'Public' },
    is_active: { type: String, enum: ["0", "1"], default: "1" },
    is_delete: { type: String, enum: ["0", "1"], default: "0" },
},
    { timestamps: true }
);
postsModel.plugin(AutoIncrement, { id: 'posts', inc_field: 'id' });
module.exports = mongoose.model('posts', postsModel);