const mongoose = require('mongoose');
const AutoIncrement = require('mongoose-sequence')(mongoose);
const Schema = mongoose.Schema;
const models = mongoose.models;
const questionsAnswersModel = new Schema({
    question_id: { type: mongoose.Schema.Types.ObjectId, ref: 'questions' },
    answer: { type: String, default: '' },
    is_delete: { type: String, enum: [0, 1], default: 0 },
},
    { timestamps: true }
);
questionsAnswersModel.plugin(AutoIncrement, { id: 'questions_answers', inc_field: 'id' });
module.exports = mongoose.model('questions_answers', questionsAnswersModel);