const mongoose = require('mongoose');
const AutoIncrement = require('mongoose-sequence')(mongoose);
const Schema = mongoose.Schema;
const models = mongoose.models;
const reelsModel = new Schema({
    user_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    media_type: { type: String, default: '' },
    media: { type: String, default: '' },
    thumb_image: { type: String, default: '' },
    music: { type: String, default: '' },
    description: { type: String, default: '' },
    privacy: { type: String, default: '' },
    is_delete: { type: String, enum: ["0", "1"], default: "0" },
    viewCount: { type: Number, default: 0 },
    index_number: { type: Number, default: 0 },
    location: { type: String, default: '' },
    location_latitude: { type: String, default: '' },
    location_longitude: { type: String, default: '' },
    location_full_address: { type: String, default: '' },
},
    { timestamps: true }
);
// reelsModel.index({ expiresAt: 1 }); // TTL index for automatic expiration
reelsModel.plugin(AutoIncrement, { id: 'reels', inc_field: 'id' });
module.exports = mongoose.model('reels', reelsModel);