const mongoose = require('mongoose');
const AutoIncrement = require('mongoose-sequence')(mongoose);
const Schema = mongoose.Schema;
const models = mongoose.models;
const storiesModel = new Schema({
    user_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    index_number: { type: String, default: '0' },
    media_type: { type: String, default: '' },
    media: { type: String, default: '' },
    thumb_image: { type: String, default: '' },
    music: { type: String, default: '' },
    privacy: { type: String, default: '' },
    duration: { type: Number, default: 24 * 60 * 60 }, // duration in seconds (default 24 hours)
    expiresAt: { type: Date, required: true },
    is_delete: { type: String, enum: [0, 1], default: 0 },
    is_expired: { type: String, enum: ["0", "1"], default: "0" },
    viewCount: { type: Number, default: 0 },
    location: { type: String, default: '' },
    location_latitude: { type: String, default: '' },
    location_longitude: { type: String, default: '' },
    location_full_address: { type: String, default: '' },
},
    { timestamps: true }
);
// storiesModel.index({ expiresAt: 1 }); // TTL index for automatic expiration
storiesModel.plugin(AutoIncrement, { id: 'stories', inc_field: 'id' });
module.exports = mongoose.model('stories', storiesModel);