const mongoose = require('mongoose');
const AutoIncrement = require('mongoose-sequence')(mongoose);
const Schema = mongoose.Schema;
const models = mongoose.models;
const storyReportModel = new Schema({
    user_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    story_id: { type: mongoose.Schema.Types.ObjectId, ref: 'stories' },
    reason_id: { type: mongoose.Schema.Types.ObjectId, ref: 'report_reasons' },
    description: { type: String, default: '' }
},
    { timestamps: true }
);
storyReportModel.plugin(AutoIncrement, { id: 'story_report', inc_field: 'id' });
module.exports = mongoose.model('story_report', storyReportModel);