const mongoose = require('mongoose');
const AutoIncrement = require('mongoose-sequence')(mongoose);
const Schema = mongoose.Schema;
const UserModel = new Schema({
    social_id: { type: String, default: '' },
    first_name: { type: String, default: '' },
    last_name: { type: String, default: '' },
    username: { type: String, default: '' },
    nickname: { type: String, default: '' },
    gender: { type: String, default: 0 },/* 0->Male, 1-> Female, 2-> Others */
    other_gender: { type: String, default: 0 },
    add_other_gender: { type: String, default: '' },
    blood_type: { type: String, default: 0 },
    love_language: [{ type: mongoose.Schema.Types.ObjectId, ref: 'love_languages' }],
    email: { type: String, default: '' },
    country_code: { type: String, default: '' },
    phone: { type: String, default: '' },
    otp: { type: String, default: '', maxLength: 6 },
    secondary_email: { type: String, default: '' },
    secondary_country_code: { type: String, default: '' },
    secondary_phone: { type: String, default: '' },
    dob: { type: Date },
    password: { type: String, default: '' },
    zip_code: { type: String, default: '' },
    is_biomatric_enable: { type: String, enum: [1, 0], default: 0, },
    login_type: { type: String, enum: ['S', 'F', 'G'], default: 'S' }, /* S-> Simple, F-> Facebook, G-> Google */
    user_type: { type: String, enum: ['U', 'P'], default: 'U' }, /* S-> Simple, F-> Facebook, G-> Google */
    profile_image: { type: String, default: '' },
    personality_type: { type: String, default: '' },
    chat_status: { type: String, default: 'offline' },
    referral_code: { type: String, default: '' },
    referred_by: { type: mongoose.Schema.Types.ObjectId, ref: 'users', default: mongoose.Types.ObjectId.empty },
    profile_type: { type: String, enum: ['Public', 'Private'], default: 'Public' },
    status: { type: String, enum: ['Active', 'Inactive'], default: 'Active' },
    signup_step: { type: String, enum: ['SIGNUP', 'VERIFY', 'DONE'], default: 'SIGNUP' },
    forgot_pin: { type: String, enum: ['1', '0'], default: '0', },
    is_verify: { type: String, enum: ['1', '0'], default: '0', },
    is_pin_set: { type: String, enum: ['1', '0'], default: '0', },
    pin: { type: String, default: '' },
    is_active: { type: String, enum: ['1', '0'], default: '1', },
    is_delete: { type: String, enum: ['1', '0'], default: '0', },
    is_business: { type: String, enum: ['1', '0'], default: '0', }
},
    { timestamps: true }
);
UserModel.plugin(AutoIncrement, { id: 'users', inc_field: 'id' });
module.exports = mongoose.model('users', UserModel);