const mongoose = require('mongoose');
const AutoIncrement = require('mongoose-sequence')(mongoose);
const Schema = mongoose.Schema;
const models = mongoose.models;
const UserBusinessModel = new Schema({
    user_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    business_name: { type: String, default: '' },
    business_email: { type: String, default: '' },
    business_profile: { type: String, default: '' },
    business_address: { type: String, default: '' },
    business_type: { type: String, default: '' },
    business_file: { type: String, default: '' },
},
    { timestamps: true }
);
UserBusinessModel.plugin(AutoIncrement, { id: 'user_business', inc_field: 'id' });
module.exports = mongoose.model('user_business', UserBusinessModel);