const mongoose = require('mongoose');
const AutoIncrement = require('mongoose-sequence')(mongoose);
const Schema = mongoose.Schema;
const models = mongoose.models;
const UserDeviceInfoModel = new Schema({
    user_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    token: { type: String, default: '' },
    device_type: { type: String, enum: ['A', 'I', 'W'], default: 'A' },
    device_token: { type: String, default: '' },
    voip_token: { type: String, default: '' },
    uuid: { type: String, default: '' },
    os_version: { type: String, default: '' },
    device_name: { type: String, default: '' },
    model_name: { type: String, default: '' },
    ip: { type: String, default: '' }
},
    { timestamps: true }
);
UserDeviceInfoModel.plugin(AutoIncrement, { id: 'device_info', inc_field: 'id' });
module.exports = mongoose.model('user_device_info', UserDeviceInfoModel);