const mongoose = require('mongoose');
const AutoIncrement = require('mongoose-sequence')(mongoose);
const Schema = mongoose.Schema;
const models = mongoose.models;
const UserFriendsModel = new Schema({
    user_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    friend_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    is_delete: { type: String, enum: [0, 1], default: 0 },
},
    { timestamps: true }
);
UserFriendsModel.plugin(AutoIncrement, { id: 'user_friends', inc_field: 'id' });
module.exports = mongoose.model('user_friends', UserFriendsModel);