const mongoose = require('mongoose');
const AutoIncrement = require('mongoose-sequence')(mongoose);
const Schema = mongoose.Schema;
const models = mongoose.models;
const UserInterestsModel = new Schema({
    user_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    interest_id: { type: mongoose.Schema.Types.ObjectId, ref: 'interests' },
    is_delete: { type: String, enum: [0, 1], default: 0 },
},
    { timestamps: true }
);
UserInterestsModel.plugin(AutoIncrement, { id: 'user_interests', inc_field: 'id' });
module.exports = mongoose.model('user_interests', UserInterestsModel);