const mongoose = require('mongoose');
const AutoIncrement = require('mongoose-sequence')(mongoose);
const Schema = mongoose.Schema;
const models = mongoose.models;
const userQuestionAnswersModel = new Schema({
    user_id: { type: mongoose.Schema.Types.ObjectId, ref: 'users' },
    question_id: { type: mongoose.Schema.Types.ObjectId, ref: 'questions' },
    answer_id: { type: mongoose.Schema.Types.ObjectId, ref: 'questions_answers' },
    is_delete: { type: String, enum: [0, 1], default: 0 },
},
    { timestamps: true }
);
userQuestionAnswersModel.plugin(AutoIncrement, { id: 'user_question_answers', inc_field: 'id' });
module.exports = mongoose.model('user_question_answers', userQuestionAnswersModel);