let express = require('express');
let router = express.Router();
const Validator = require('Validator');
const common_model = require('./common_model')
let common = require('../../../utilities/common')
let validate_header = require('../../../middleware/validate-header');
const httpStatusCode = require('http-status-codes');
let { t } = require('localizify');
/* function used to contactus */
router.post('/getQuestion', (req, res) => {
    // console.log("AddContactUs", req.body)
    let request = req.body;

    common_model.getQuestion(request, (code, message, response) => {
        let response_data = {
            code: code,
            message: message
        }
        if (code == "1") {
            response_data.data = response;
        }
        validate_header.send_response(req, res, response_data);
    })
})
/* function used to contactus */
router.post('/getInterests', (req, res) => {
    // console.log("AddContactUs", req.body)
    let request = req.body;

    common_model.getInterests(request, (code, message, response) => {
        let response_data = {
            code: code,
            message: message
        }
        if (code == "1") {
            response_data.data = response;
        }
        validate_header.send_response(req, res, response_data);
    })
})
/* function used to get all love languages */
router.post('/getLoveLanguage', (req, res) => {
    let request = req.body;

    common_model.getLoveLanguage(request, (code, message, response) => {
        let response_data = {
            code: code,
            message: message
        }
        if (code == "1") {
            response_data.data = response;
        }
        validate_header.send_response(req, res, response_data);
    })
})
/* function used to getBloods */
router.post('/getBloods', (req, res) => {
    let request = req.body;

    common_model.getBloods(request, (code, message, response) => {
        let response_data = {
            code: code,
            message: message
        }
        if (code == "1") {
            response_data.data = response;
        }
        validate_header.send_response(req, res, response_data);
    })
})
/* function used to getOtherGenders */
router.post('/getOtherGenders', (req, res) => {
    let request = req.body;

    common_model.getOtherGenders(request, (code, message, response) => {
        let response_data = {
            code: code,
            message: message
        }
        if (code == "1") {
            response_data.data = response;
        }
        validate_header.send_response(req, res, response_data);
    })
})
/* function used to get Relationships */
router.post('/getRelationship', (req, res) => {
    let request = req.body;

    common_model.getRelationship(request, (code, message, response) => {
        let response_data = {
            code: code,
            message: message
        }
        if (code == "1") {
            response_data.data = response;
        }
        validate_header.send_response(req, res, response_data);
    })
})
/* function used to addRelationship */
router.post('/addRelationship', (req, res) => {
    let request = req.body;

    common_model.addRelationship(request, (code, message, response) => {
        let response_data = {
            code: code,
            message: message
        }
        if (code == "1") {
            response_data.data = response;
        }
        validate_header.send_response(req, res, response_data);
    })
})
/* function used to getLoveLanguages */
router.post('/getLoveLanguages', (req, res) => {
    let request = req.body;

    common_model.getLoveLanguages(request, (code, message, response) => {
        let response_data = {
            code: code,
            message: message
        }
        if (code == "1") {
            response_data.data = response;
        }
        validate_header.send_response(req, res, response_data);
    })
})
/* function used to searchHashtag */
router.post('/searchHashtag', (req, res) => {
    let request = req.body;
    common_model.searchHashtag(request, (code, message, response) => {
        let response_data = {
            code: code,
            message: message
        }
        if (code == "1") {
            response_data.data = response;
        }
        validate_header.send_response(req, res, response_data);
    })
})
/* function used to searchHashtag */
router.post('/getProfileForPost', (req, res) => {
    let request = req.body;
    common_model.getProfileForPost(request, (code, message, response) => {
        let response_data = {
            code: code,
            message: message
        }
        if (code == "1") {
            response_data.data = response;
        }
        validate_header.send_response(req, res, response_data);
    })
})
/* function used to getReactions */
router.post('/getReactions', (req, res) => {
    let request = req.body;

    common_model.getReactions(request, (code, message, response) => {
        let response_data = {
            code: code,
            message: message
        }
        if (code == "1") {
            response_data.data = response;
        }
        validate_header.send_response(req, res, response_data);
    })
})
/* function used to Report Reasons */
router.post('/reportReasonList', (req, res) => {
    let request = req.body;

    common_model.storyReportReasonList(request, (code, message, response) => {
        let response_data = {
            code: code,
            message: message
        }
        if (code == "1") {
            response_data.data = response;
        }
        validate_header.send_response(req, res, response_data);
    })
})
router.post('/colorList', (req, res) => {
    let request = req.body;

    common_model.colorList(request, (code, message, response) => {
        let response_data = {
            code: code,
            message: message
        }
        if (code == "1") {
            response_data.data = response;
        }
        validate_header.send_response(req, res, response_data);
    })
})
module.exports = router;
