var responseCode = require('../../../config/response-error-code');
var con = require('../../../config/database');
var constant = require('../../../config/constant');
var common = require('../../../utilities/common');
var template = require('../../../utilities/template')
var { t } = require('localizify');
var md5 = require('md5');
var asyncLoop = require('node-async-loop');
var moment = require('moment');
var notiLibrary = require('../../../config/notification');
const chat_model = {
    /*
    * create chat room
    */
    create_chat_room: (req, callback) => {
        var query = "SELECT * FROM tbl_chat_room WHERE isGroupChat=0 and (user1 IN ('" + req.sender_id + "','" + req.receiver_id + "')) AND (user2 IN ('" + req.receiver_id + "', '" + req.sender_id + "'))";
        con.query(query, (err, chat_room, fields) => {
            console.log(chat_room)
            if (!err && chat_room != undefined && chat_room != '') {
                chat_model.get_receivers_details({ chat_room_id: chat_room[0].id, sender_id: req.sender_id }, (code, msg, user) => {
                    if (code == 1 || code == '1') {
                        var data = {
                            'chat_room_id': chat_room[0].id,
                            'isGroupChat': chat_room[0].isGroupChat,
                            'user_details': user
                        }
                        callback(code, t('rest_keywords_success'), data);
                    } else {
                        callback(code, msg, null);
                    }
                })
            }
            else {
                var params = {
                    isGroupChat: 0,
                    user1: req.sender_id,
                    user2: req.receiver_id,
                }
                con.query('INSERT INTO tbl_chat_room SET ?', [params], (err, result, fields) => {
                    if (!err) {
                        if (result.affectedRows > 0) {
                            chat_model.get_receivers_details({ chat_room_id: result.insertId, sender_id: req.sender_id }, (code, msg, user) => {
                                if (code == 1 || code == '1') {
                                    var data = {
                                        'chat_room_id': result.insertId,
                                        'isGroupChat': 0,
                                        'user_details': user
                                    }
                                    callback(code, t('rest_keywords_success'), data);
                                } else {
                                    callback(code, msg, null);
                                }
                            })
                            // let query1 = "SELECT tu.id as user_id, tu.name,tu.country_code,tu.phone,IF( tu.profile_image !='', concat('" + constant.profile_image + "','',tu.profile_image), '' ) as profile_image,IF( tu.chat_wallpaper !='', concat('" + constant.chat_wallpaper + "','',tu.chat_wallpaper), '' ) as chat_wallpaper,qrcode_image FROM tbl_users AS tu WHERE tu.id= '" + req.receiver_id + "'";
                            // con.query(query1, (err1, result1) => {

                            // })
                        }
                        else {
                            callback(responseCode.NO_DATA_FOUND, t('rest_keywords_no_data_found'), null);
                        }
                    }
                    else {
                        callback(responseCode.OPERATION_FAILED, t('rest_keywords_something_went_wrong'), null);
                    }
                });
            }
        });
    },
    get_single_chat_room: (req, callback) => {
        var query = "SELECT * FROM tbl_chat_room WHERE isGroupChat=0 and (user1 IN ('" + req.sender_id + "','" + req.receiver_id + "')) AND (user2 IN ('" + req.receiver_id + "', '" + req.sender_id + "'))";
        // console.log(query)
        con.query(query, (err, chat_room) => {
            if (!err) {
                // console.log(chat_room)
                if (chat_room.length > 0) {
                    callback(responseCode.SUCCESS, t('data_not_found'), chat_room[0]);

                } else {
                    callback(responseCode.NO_DATA_FOUND, t('data_not_found'), {});
                }
            } else {
                // console.log(err)

                callback(responseCode.OPERATION_FAILED, err, {});
            }
        })
    },
    /*
    * create chat room for group
    */
    create_group: (req, callback) => {
        var sql = "insert into tbl_chat_room set ?";
        var data = {
            isGroupChat: 1,
            chat_name: req.chat_name,
            created_by: req.user_id
        }
        if (req.description != undefined) {
            data.description = req.description;
        }
        if (req.profile_image != undefined) {
            data.profile_image = req.profile_image;
        }
        con.query(sql, data, (_err, _group) => {
            if (_err) {
                callback(responseCode.OPERATION_FAILED, _err, null);

            } else {
                req.users.push(req.user_id);
                asyncLoop(req.users, (item, next) => {
                    var user_data = {
                        chat_room_id: _group.insertId,
                        user_id: item,
                    }
                    if (req.user_id == item) {
                        user_data.is_admin = 1;
                    }
                    var sql = "insert into tbl_chat_users set ?";
                    con.query(sql, user_data, (_err, _user) => {
                        if (_err) {
                            next(_err);
                            return;
                        } else {
                            next();
                        }
                    })
                }, (err) => {
                    if (err) {
                        callback(responseCode.OPERATION_FAILED, err, null);
                    } else {
                        let query1 = "SELECT tu.id as user_id, tu.name,tu.country_code,tu.phone,tcu.is_admin,IF( tu.profile_image !='', concat('" + constant.profile_image + "','',tu.profile_image), '' ) as profile_image,IF( tu.chat_wallpaper !='', concat('" + constant.chat_wallpaper + "','',tu.chat_wallpaper), '' ) as chat_wallpaper,qrcode_image FROM tbl_users AS tu left join tbl_chat_users as tcu on tu.id=tcu.user_id WHERE tcu.chat_room_id='" + _group.insertId + "'";
                        con.query(query1, (err1, result1) => {
                            if (err1) {
                                callback(responseCode.OPERATION_FAILED, err1, null);
                            } else {
                                if (req.profile_image != undefined) {
                                    var pr = constant.chat_file + req.profile_image;
                                } else {
                                    var pr = '';
                                }
                                chat_model.get_admin_detail({ chat_room_id: _group.insertId }, (err, _admin) => {
                                    asyncLoop(req.users, (item, next) => {
                                        if (item != req.user_id) {

                                            var response_data = {
                                                chat_room_id: _group.insertId,
                                                chat_profile: pr,
                                                chat_group_name: req.chat_name,
                                                admin_detail: _admin[0],
                                                admin_can_send_message: data.admin_can_send_message,
                                                hide_phone_users: data.hide_phone_users,
                                            }
                                            console.log("you_added_in_group response_data", response_data)
                                            var socket = global._unic_sokect_;
                                            if (global._unic_sokect_user[item] != undefined) {
                                                socket.to(global._unic_sokect_user[item]['socket']).emit('you_added_in_group', response_data);
                                                next();
                                            } else {
                                                var insert_data = {
                                                    emit_type: 'you_added_in_group',
                                                    emit_to: item,
                                                    emit_response: JSON.stringify(response_data)
                                                };
                                                chat_model.store_emit(insert_data, (result) => {
                                                    next();
                                                })
                                            }
                                        }
                                        else {
                                            next();
                                        }
                                    }, () => {
                                        var resp = {
                                            chat_room_id: _group.insertId,
                                            'isGroupChat': 1,
                                            userCount: req.users.length,
                                            admin_can_send_message: data.admin_can_send_message,
                                            hide_phone_users: data.hide_phone_users,
                                            adminDetail: _admin[0],
                                            chat_name: req.chat_name,
                                            profile_image: pr,
                                            'user_details': result1
                                        };
                                        // console.log(resp)
                                        callback(responseCode.SUCCESS, t('group_created'), resp)
                                    })

                                })


                            }

                        })
                    }
                })
            }
        })
    },
    get_admin_detail: (req, callback) => {
        let query1 = "SELECT tu.id as user_id, tu.name,tu.country_code,tu.phone,tcu.is_admin,IF( tu.profile_image !='', concat('" + constant.profile_image + "','',tu.profile_image), '' ) as profile_image,IF( tu.chat_wallpaper !='', concat('" + constant.chat_wallpaper + "','',tu.chat_wallpaper), '' ) as chat_wallpaper,qrcode_image FROM tbl_users AS tu left join tbl_chat_users as tcu on tu.id=tcu.user_id WHERE tcu.chat_room_id='" + req.chat_room_id + "' and tcu.is_admin=1";
        con.query(query1, (_err, _data) => {
            if (_err) {
                callback(_err, undefined);
            } else {
                callback(undefined, _data);
            }
        })
    },
    /*
    * chat room list
    */
    get_chat_room_list: (req, callback) => {
        console.log("get_chat_room_list", req)
        if (req.chat_room_type != undefined && req.chat_room_type == 'group') {
            var sql = "select tcr.id as chat_room_id,tcr.isGroupChat,tcr.chat_name,IF(tcr.profile_image !='', concat('" + constant.chat_file + "','',tcr.profile_image), '' ) as profile_image,tcr.description,tcr.updated_at,tcr.hide_phone_users,tcr.admin_can_send_message,tcr.created_by from tbl_chat_room as tcr left join tbl_chat_users as tcu on tcr.id=tcu.chat_room_id where tcr.isGroupChat=1 and tcu.user_id=? and tcu.is_delete!=1 and tcr.status='Active' group by tcr.id";
            // console.log(sql)
            con.query(sql, req.user_id, (_err, _chat_room) => {
                // console.log("_chat_room", _chat_room)
                if (_err) {
                    callback(responseCode.OPERATION_FAILED, _err, null);
                } else {
                    if (_chat_room.length > 0) {
                        asyncLoop(_chat_room, (item, next) => {
                            chat_model.getSingleLastMessage({ chat_room_id: item.chat_room_id }, (chat_data) => {
                                item.last_message = chat_data;
                                chat_model.is_starred_message({ user_id: req.user_id, message_id: chat_data.id }, (stm) => {
                                    item.last_message.is_starred = stm;
                                    chat_model.get_receivers_details({ chat_room_id: item.chat_room_id, sender_id: req.user_id }, (code, msg, user) => {
                                        if (code == 1 || code == '1') {
                                            item.receiver_details = user;
                                            item.user_count = user.length + 1;
                                            chat_model.get_admin_detail({ chat_room_id: item.chat_room_id }, (err, data) => {
                                                if (!err) {
                                                    item.admin_detail = data;
                                                } else {
                                                    item.admin_detail = []
                                                }
                                                chat_model.get_unread_count({ chat_room_id: item.chat_room_id, user_id: req.user_id }, (count) => {
                                                    item.unread_count = count;
                                                    chat_model.get_sender_details({ sender_id: item.created_by }, (code, msg, data) => {
                                                        item.created_by_detail = data[0];
                                                        next();
                                                    })
                                                })
                                            })
                                        } else {
                                            next(msg);
                                            return;
                                        }
                                    })
                                })
                            })
                        }, (err) => {
                            if (err) {
                                callback(responseCode.OPERATION_FAILED, err, null);
                            } else {
                                var response_data = [];
                                asyncLoop(_chat_room, (item, next) => {
                                    if (Object.keys(item.last_message).length === 0) {
                                        next();
                                    } else {
                                        response_data.push(item)
                                        next();
                                    }
                                })
                                callback(responseCode.SUCCESS, t('data_found'), _chat_room);
                            }
                        })
                    } else {
                        callback(responseCode.NO_DATA_FOUND, t('data_not_found'), []);
                    }
                }
            })
        } else if (req.chat_room_type != undefined && req.chat_room_type == 'single') {
            var query = "SELECT *,id as chat_room_id,IF(profile_image !='', concat('" + constant.chat_file + "','',profile_image), '' ) as profile_image FROM tbl_chat_room WHERE isGroupChat=0 and (user1='" + req.user_id + "' OR user2='" + req.user_id + "') and status='Active' group by id";
            con.query(query, (_err, _chat_room1) => {
                if (_err) {
                    callback(responseCode.OPERATION_FAILED, _err, null);
                } else {
                    if (_chat_room1.length > 0) {
                        asyncLoop(_chat_room1, (item, next) => {
                            chat_model.getSingleLastMessage({ chat_room_id: item.chat_room_id }, (chat_data) => {
                                item.last_message = chat_data;
                                chat_model.is_starred_message({ user_id: req.user_id, message_id: chat_data.id }, (stm) => {
                                    item.last_message.is_starred = stm;
                                    chat_model.get_receivers_details({ chat_room_id: item.chat_room_id, sender_id: req.user_id }, (code, msg, user) => {
                                        if (code == 1 || code == '1') {
                                            item.receiver_details = user;
                                            item.user_count = user.length + 1;
                                            item.chat_name = (user.length > 0) ? user[0].name : '';
                                            item.profile_image = (user.length > 0) ? user[0].profile_image : '';
                                            chat_model.get_unread_single_chat_count({ chat_room_id: item.chat_room_id, user_id: req.user_id }, (count) => {
                                                item.unread_count = count;
                                                next();
                                            })
                                        } else {
                                            next(msg);
                                            return;
                                        }
                                    })
                                })
                            })
                        }, (err) => {
                            if (err) {
                                callback(responseCode.OPERATION_FAILED, err, null);

                            } else {
                                var response_data = [];
                                asyncLoop(_chat_room1, (item, next) => {
                                    if ((Object.keys(item.last_message).length === 0) && item.receiver_details.length == 0) {
                                        next();
                                    } else {
                                        response_data.push(item)
                                        next();
                                    }
                                })
                                callback(responseCode.SUCCESS, t('data_found'), response_data);
                            }
                        })
                    } else {
                        callback(responseCode.NO_DATA_FOUND, t('data_not_found'), []);
                    }
                }
            })
        } else {
            var sql = "select tcr.id as chat_room_id,tcr.isGroupChat,tcr.chat_name,IF(tcr.profile_image !='', concat('" + constant.chat_file + "','',tcr.profile_image), '' ) as profile_image,tcr.description,tcr.updated_at,tcr.hide_phone_users,tcr.admin_can_send_message,tcr.created_by  from tbl_chat_room as tcr join tbl_chat_users as tcu on tcr.id=tcu.chat_room_id where tcr.isGroupChat='1' and tcr.status='Active' and tcu.user_id=? and tcu.is_delete!=1 group by tcr.id";
            con.query(sql, req.user_id, (_err, _chat_room) => {
                if (_err) {
                    callback(responseCode.OPERATION_FAILED, _err, null);
                } else {

                    if (_chat_room.length > 0) {
                        // console.log("_chat_room", _chat_room)

                        asyncLoop(_chat_room, (item, next) => {
                            chat_model.getSingleLastMessage({ chat_room_id: item.chat_room_id }, (chat_data) => {
                                item.last_message = chat_data;
                                // console.log("chat_data", chat_data)
                                chat_model.is_starred_message({ user_id: req.user_id, message_id: chat_data.id }, (stm) => {
                                    item.is_starred = stm;
                                    chat_model.get_receivers_details({ chat_room_id: item.chat_room_id, sender_id: req.user_id }, (code, msg, user) => {
                                        if (code == 1 || code == '1') {
                                            item.receiver_details = user;
                                            item.user_count = user.length + 1;
                                            chat_model.get_admin_detail({ chat_room_id: item.chat_room_id }, (err, data) => {
                                                if (!err) {
                                                    item.admin_detail = data;
                                                } else {
                                                    item.admin_detail = []
                                                }
                                                chat_model.get_unread_count({ chat_room_id: item.chat_room_id, user_id: req.user_id }, (count) => {
                                                    item.unread_count = count;
                                                    chat_model.get_sender_details({ sender_id: item.created_by }, (code, msg, data) => {
                                                        item.created_by_detail = data[0];
                                                        next();
                                                    })
                                                })
                                            })
                                        } else {
                                            next(msg);
                                            return;
                                        }
                                    })
                                })
                            })
                        }, (err) => {
                            if (err) {
                                callback(responseCode.OPERATION_FAILED, err, null);
                            } else {
                                var query = "SELECT *,id as chat_room_id,IF(profile_image !='', concat('" + constant.chat_file + "','',profile_image), '' ) as profile_image FROM tbl_chat_room WHERE isGroupChat='0' and (user1='" + req.user_id + "' OR user2='" + req.user_id + "')";
                                con.query(query, (_err, _chat_room1) => {
                                    if (_err) {
                                        callback(responseCode.OPERATION_FAILED, _err, null);
                                    } else {
                                        if (_chat_room1.length > 0) {
                                            console.log(_chat_room1.length)
                                            asyncLoop(_chat_room1, (item, next) => {
                                                chat_model.getSingleLastMessage({ chat_room_id: item.id }, (chat_data) => {
                                                    item.last_message = chat_data;
                                                    chat_model.is_starred_message({ user_id: req.user_id, message_id: chat_data.id }, (stm) => {
                                                        item.is_starred = stm;
                                                        chat_model.get_receivers_details({ chat_room_id: item.id, sender_id: req.user_id }, (code, msg, user) => {
                                                            if (code == 1 || code == '1') {
                                                                item.receiver_details = user;
                                                                item.user_count = user.length + 1;
                                                                // item.chat_name = (user[0].name != undefined) ? user[0].name : '';
                                                                // item.profile_image = (user[0].profile_image != undefined) ? user[0].profile_image : ''
                                                                chat_model.get_unread_single_chat_count({ chat_room_id: item.chat_room_id, user_id: req.user_id }, (count) => {
                                                                    item.unread_count = count;
                                                                    next();
                                                                })
                                                            } else {
                                                                next(msg);
                                                                return;
                                                            }
                                                        })
                                                    })
                                                })
                                            }, (err) => {
                                                if (err) {
                                                    callback(responseCode.OPERATION_FAILED, err, null);
                                                } else {
                                                    var response_arr = _chat_room.concat(_chat_room1);
                                                    console.log(response_arr.length)

                                                    response_arr = response_arr.sort(function (a, b) {
                                                        var dateA = new Date(a.updated_at).getTime();
                                                        var dateB = new Date(b.updated_at).getTime();
                                                        return dateA < dateB ? 1 : -1; // ? -1 : 1 for ascending/increasing order
                                                    });
                                                    var response_data = [];
                                                    asyncLoop(response_arr, (item, next) => {
                                                        if (Object.keys(item.last_message).length === 0) {
                                                            next();
                                                        } else {
                                                            response_data.push(item)
                                                            next();
                                                        }
                                                    })
                                                    callback(responseCode.SUCCESS, t('data_found'), response_data);
                                                }
                                            })
                                        } else {
                                            callback(responseCode.SUCCESS, t('data_found'), _chat_room);
                                        }
                                    }
                                })
                            }
                        })
                    } else {
                        var query = "SELECT *,id as chat_room_id,IF(profile_image !='', concat('" + constant.chat_file + "','',profile_image), '' ) as profile_image FROM tbl_chat_room WHERE isGroupChat=0 and (user1='" + req.user_id + "' OR user2='" + req.user_id + "')";
                        con.query(query, (_err, _chat_room1) => {
                            if (_err) {
                                callback(responseCode.OPERATION_FAILED, _err, null);
                            } else {
                                var rrr = [];
                                if (_chat_room1.length > 0) {
                                    asyncLoop(_chat_room1, (item, next) => {
                                        chat_model.getSingleLastMessage({ chat_room_id: item.id }, (chat_data) => {
                                            // console.log("chat_room_id: " + item.id + " => ", chat_data.length)
                                            item.last_message = chat_data;
                                            chat_model.is_starred_message({ user_id: req.user_id, message_id: chat_data.id }, (stm) => {
                                                item.is_starred = stm;
                                                chat_model.get_receivers_details({ chat_room_id: item.id, sender_id: req.user_id }, (code, msg, user) => {
                                                    if (code == 1 || code == '1') {
                                                        item.receiver_details = user;
                                                        chat_model.get_unread_single_chat_count({ chat_room_id: item.chat_room_id, user_id: req.user_id }, (count) => {
                                                            item.unread_count = count;
                                                            next();
                                                        })
                                                    } else {
                                                        next(msg);
                                                        return;
                                                    }
                                                })
                                            })
                                        })
                                    }, (err) => {
                                        if (err) {
                                            callback(responseCode.OPERATION_FAILED, err, null);
                                        } else {
                                            var response_data = [];
                                            asyncLoop(_chat_room1, (item, next) => {
                                                if (Object.keys(item.last_message).length === 0) {
                                                    next();
                                                } else {
                                                    response_data.push(item)
                                                    next();
                                                }
                                            })
                                            callback(responseCode.SUCCESS, t('data_found'), response_data);
                                        }
                                    })
                                } else {
                                    callback(responseCode.SUCCESS, t('data_not_found'), {});
                                }
                            }
                        })
                    }
                }
            })
        }
    },
    /*
    * chat room list
    */
    get_receivers_details: (req, callback) => {
        var sql = "select * from tbl_chat_room where id=?";
        con.query(sql, req.chat_room_id, (_err, _data) => {
            if (_err) {
                callback(responseCode.OPERATION_FAILED, _err, null);
            } else {
                if (_data.length > 0) {
                    if (_data[0].isGroupChat == 1) {
                        var sql = "SELECT tu.id as user_id, tu.name,tu.country_code,tu.phone,tcu.is_admin,tu.text_notification,tu.device_type,tu.voip_token,tu.device_token,IF( tu.profile_image !='', concat('" + constant.profile_image + "','',tu.profile_image), '' ) as profile_image,IF( tu.chat_wallpaper !='', concat('" + constant.chat_wallpaper + "','',tu.chat_wallpaper), '' ) as chat_wallpaper,qrcode_image FROM tbl_users AS tu left join tbl_chat_users as tcu on tu.id=tcu.user_id WHERE tcu.chat_room_id='" + _data[0].id + "' and tcu.user_id!='" + req.sender_id + "'";
                        con.query(sql, (_err, _chat_room_users) => {
                            if (_err) {
                                callback(responseCode.OPERATION_FAILED, _err, null);
                            } else {
                                if (_chat_room_users.length > 0) {
                                    callback(responseCode.SUCCESS, t('data_found'), _chat_room_users);
                                } else {
                                    callback(responseCode.SUCCESS, t('data_not_found'), []);
                                }
                            }
                        })
                    } else {
                        // console.log("_data[0]================" + req.sender_id + "================", _data[0])
                        if (req.sender_id == _data[0].user1) {
                            var sql = "SELECT tu.id as user_id, tu.name,tu.country_code,tu.phone,tu.text_notification,tu.device_type,tu.voip_token,tu.device_token,IF( tu.profile_image !='', concat('" + constant.profile_image + "','',tu.profile_image), '' ) as profile_image,IF( tu.chat_wallpaper !='', concat('" + constant.chat_wallpaper + "','',tu.chat_wallpaper), '' ) as chat_wallpaper,qrcode_image FROM tbl_users AS tu  WHERE tu.id='" + _data[0].user2 + "'";
                        } else {
                            var sql = "SELECT tu.id as user_id, tu.name,tu.country_code,tu.phone,tu.text_notification,tu.device_type,tu.voip_token,tu.device_token,IF( tu.profile_image !='', concat('" + constant.profile_image + "','',tu.profile_image), '' ) as profile_image,IF( tu.chat_wallpaper !='', concat('" + constant.chat_wallpaper + "','',tu.chat_wallpaper), '' ) as chat_wallpaper,qrcode_image FROM tbl_users AS tu  WHERE tu.id='" + _data[0].user1 + "'";
                        }

                        con.query(sql, (_err, _chat_room_users) => {
                            if (_err) {
                                callback(responseCode.OPERATION_FAILED, _err, null);
                            } else {
                                if (_chat_room_users.length > 0) {
                                    callback(responseCode.SUCCESS, t('data_found'), _chat_room_users);
                                } else {
                                    callback(responseCode.SUCCESS, t('data_not_found'), []);
                                }
                            }
                        })
                    }
                } else {
                    callback(responseCode.SUCCESS, t('data_not_found'), []);
                }

            }
        })
    },
    /*
  * chat room list
  */
    get_sender_details: (req, callback) => {
        var sql = "SELECT tu.id as user_id, tu.name,tu.country_code,tu.phone,tu.text_notification,IF( tu.profile_image !='', concat('" + constant.profile_image + "','',tu.profile_image), '' ) as profile_image,IF( tu.chat_wallpaper !='', concat('" + constant.chat_wallpaper + "','',tu.chat_wallpaper), '' ) as chat_wallpaper,qrcode_image FROM tbl_users AS tu  WHERE tu.id='" + req.sender_id + "'";
        con.query(sql, (_err, _sender_user) => {
            if (_err) {
                callback(responseCode.OPERATION_FAILED, _err, null);
            } else {
                callback(responseCode.SUCCESS, t('data_found'), _sender_user);
            }
        })
    },
    /*
  * chat room list
  */
    is_starred_message: (req, callback) => {
        var sql = "SELECT * FROM tbl_starred_message AS tsm  WHERE tsm.user_id=? and tsm.message_id=?";
        con.query(sql, [req.user_id, req.message_id], (_err, stm_data) => {
            if (_err) {
                console.log("is_starred_message", _err);
                callback(0);
            } else {
                if (stm_data.length > 0) {
                    callback(1)
                } else {
                    callback(0)
                }
            }
        })
    },
    get_unread_count: (req, callback) => {
        var sql = "select * from tbl_chat_clear where chat_room_id=? and user_id=?";
        con.query(sql, [req.chat_room_id, req.user_id], (_err, _data) => {
            if (!_err) {
                if (_data.length > 0) {
                    var sql = "SELECT count(tcm.id) as unread_count FROM tbl_chat_messages as tcm where tcm.chat_room_id='" + req.chat_room_id + "'  and tcm.sender_id!='" + req.user_id + "'and tcm.created_at > '" + moment(_data[0].clear_date).format('YYYY-MM-DD HH:mm:ss') + "' and (select count(tcmru.id) from tbl_chat_message_read_users as tcmru where tcmru.message_id=tcm.id and tcmru.user_id='" + req.user_id + "')=0;"
                } else {
                    var sql = "SELECT count(tcm.id) as unread_count FROM tbl_chat_messages as tcm where tcm.chat_room_id='" + req.chat_room_id + "'  and tcm.sender_id!='" + req.user_id + "' and (select count(tcmru.id) from tbl_chat_message_read_users as tcmru where tcmru.message_id=tcm.id and tcmru.user_id='" + req.user_id + "')=0;"
                }
                con.query(sql, (_err, _res) => {
                    if (_err) {
                        console.log("get_unread_count Error:", _err);
                        callback(0);
                    } else {
                        callback(_res[0].unread_count);
                    }
                });
            } else {
                callback(0);
            }
        })

    },
    /*
    * get unread chat count
    */
    get_unread_single_chat_count: (req, callback) => {
        var sql = "select * from tbl_chat_clear where chat_room_id=? and user_id=?";
        con.query(sql, [req.chat_room_id, req.user_id], (_err, _data) => {
            if (!_err) {
                if (_data.length > 0) {
                    var query = "SELECT count(id) as unread_count FROM tbl_chat_messages WHERE chat_room_id='" + req.chat_room_id + "' and sender_id!='" + req.user_id + "' and created_at > '" + moment(_data[0].clear_date).format('YYYY-MM-DD HH:mm:ss') + "' and is_read=0";
                } else {
                    var query = "SELECT count(id) as unread_count FROM tbl_chat_messages WHERE chat_room_id='" + req.chat_room_id + "' and sender_id!='" + req.user_id + "' and is_read=0";
                }
                con.query(query, (err, result) => {
                    if (!err) {
                        if (result.length > 0) {
                            callback(result[0].unread_count);
                        } else {
                            callback(0);
                        }
                    } else {
                        callback(0);
                    }
                });
            } else {
                callback(0);
            }
        });
    },
    /*
    * get unread chat history
    */
    get_unread_chat_history: (req, callback) => {
        var sql = "select * from tbl_chat_clear where chat_room_id=? and user_id=?";
        con.query(sql, [req.chat_room_id, req.user_id], (_err, _data) => {
            if (!_err) {
                if (_data.length > 0) {
                    var query = "SELECT * FROM tbl_chat_messages WHERE chat_room_id='" + req.chat_room_id + "' and created_at > '" + moment(_data[0].clear_date).format('YYYY-MM-DD HH:mm:ss') + "' and is_read=0";
                } else {
                    var query = "SELECT * FROM tbl_chat_messages WHERE chat_room_id='" + req.chat_room_id + "' and is_read=0";
                }
                if (req.limit != undefined) {
                    req.page = (req.page == undefined || req.page < 1) ? 1 : req.page;
                    req.offset = (req.page - 1) * req.limit;
                    query = query + "LIMIT " + req.offset + ", " + req.limit + "";
                }
                con.query(query, (err, result) => {
                    //console.log(q.sql)
                    if (!err) {
                        if (result.length > 0) {
                            // console.log(result)
                            asyncLoop(result, (item, next) => {
                                if (item.message != '' && item.message != undefined) {
                                    item.message = item.message.toString();
                                    item.text_message = item.message.toString();
                                } else {
                                    item.message = '';
                                    item.text_message = '';
                                }

                                if (item.message_type == 'image' || item.message_type == 'document' || item.message_type == 'audio' || item.message_type == 'video') {
                                    item.full_file_url = constant.chat_file + item.file_url;
                                }
                                if (item.message_type == 'video') {
                                    item.thumbnail = constant.chat_file + item.thumbnail;
                                }
                                chat_model.is_starred_message({ user_id: req.user_id, message_id: item.id }, (stm) => {
                                    item.is_starred = stm;
                                    chat_model.get_sender_details({ sender_id: item.sender_id }, (code, message, data) => {
                                        if (code == 1 || code == '1') {
                                            item.sender_detail = data;
                                            if (item.is_reply == 1 || item.is_reply == '1') {
                                                con.query("SELECT * FROM tbl_chat_messages WHERE id = '" + item.message_id + "'", (err, reply_result) => {
                                                    if (!err && reply_result.length > 0) {
                                                        if (reply_result[0].message != '' && reply_result[0].message != undefined) {
                                                            reply_result[0].message = reply_result[0].message.toString();
                                                        } else {
                                                            reply_result[0].message = '';
                                                        }
                                                        if (reply_result[0].message_type == 'video') {
                                                            reply_result[0].thumbnail = constant.chat_file + reply_result[0].thumbnail;
                                                        }
                                                        if (reply_result[0].message_type == 'image' || reply_result[0].message_type == 'document' || reply_result[0].message_type == 'audio' || reply_result[0].message_type == 'video') {

                                                            reply_result[0].full_file_url = constant.chat_file + reply_result[0].file_url;
                                                        }
                                                        item.replied_message_detail = reply_result[0];
                                                        next();
                                                    } else {
                                                        item.replied_message_detail = {}
                                                        next(err);
                                                        return;
                                                    }
                                                })
                                            } else {
                                                item.replied_message_detail = {}
                                                next();
                                            }
                                            // next();
                                        } else {
                                            next(message);
                                            return;
                                        }
                                    })
                                })
                            }, (_err) => {
                                if (_err) {
                                    callback(responseCode.OPERATION_FAILED, _err, null)
                                } else {
                                    callback(responseCode.SUCCESS, t('data_found'), result);
                                }
                            })
                        } else {
                            callback(responseCode.NO_DATA_FOUND, t('data_not_found'), null);
                        }
                    }
                    else {
                        callback(responseCode.OPERATION_FAILED, err, null);
                    }
                });
            } else {
                callback(responseCode.OPERATION_FAILED, _err, null);
            }
        });
    },
    /*
    * get chat history
    */
    get_chat_history: (req, callback) => {
        console.log("get_chat_history", req)
        var sql = "select * from tbl_chat_clear where chat_room_id=? and user_id=?";
        con.query(sql, [req.chat_room_id, req.user_id], (_err, _data) => {
            if (!_err) {
                if (_data.length > 0) {
                    // console.log("get_chat_history", moment(_data[0].clear_date).format('YYYY-MM-DD HH:mm:ss'))

                    var query = "SELECT * FROM tbl_chat_messages WHERE chat_room_id='" + req.chat_room_id + "' and created_at > '" + moment(_data[0].clear_date).format('YYYY-MM-DD HH:mm:ss') + "' ";
                } else {
                    var query = "SELECT * FROM tbl_chat_messages WHERE chat_room_id='" + req.chat_room_id + "' ";
                }
                // console.log("query", query)

                if (req.limit != undefined) {
                    req.page = (req.page == undefined || req.page < 1) ? 1 : req.page;
                    req.offset = (req.page - 1) * req.limit;
                    query = query + "LIMIT " + req.offset + ", " + req.limit + "";
                }
                con.query(query, (err, result) => {
                    if (!err) {
                        if (result.length > 0) {
                            result = result.sort(function (a, b) {
                                var dateA = new Date(a.created_at).getTime();
                                var dateB = new Date(b.created_at).getTime();
                                return dateA < dateB ? -1 : 1; // ? -1 : 1 for ascending/increasing order
                            });
                            asyncLoop(result, (item, next) => {
                                if (item.message != '' && item.message != undefined) {
                                    item.message = item.message.toString();
                                    item.text_message = item.message.toString();
                                } else {
                                    item.message = '';
                                }
                                if (item.message_type == 'image' || item.message_type == 'document' || item.message_type == 'audio' || item.message_type == 'video') {
                                    item.full_file_url = constant.chat_file + item.file_url;
                                }
                                if (item.message_type == 'video') {
                                    item.thumbnail = constant.chat_file + item.thumbnail;
                                }
                                chat_model.is_starred_message({ user_id: req.user_id, message_id: item.id }, (stm) => {
                                    item.is_starred = stm;
                                    chat_model.get_sender_details({ sender_id: item.sender_id }, (code, message, data) => {
                                        if (code == 1 || code == '1') {
                                            item.sender_detail = data;
                                            if (item.is_reply == 1 || item.is_reply == '1') {
                                                con.query("SELECT * FROM tbl_chat_messages WHERE id = '" + item.message_id + "'", (err, reply_result) => {
                                                    if (!err && reply_result.length > 0) {
                                                        if (reply_result[0].message != '' && reply_result[0].message != undefined) {
                                                            reply_result[0].message = reply_result[0].message.toString();
                                                        } else {
                                                            reply_result[0].message = '';
                                                        }
                                                        if (reply_result[0].message_type == 'video') {
                                                            reply_result[0].thumbnail = constant.chat_file + reply_result[0].thumbnail;
                                                        }
                                                        var arr = ["image", "video", "audio", "document"];
                                                        if (reply_result[0].message_type == 'image' || reply_result[0].message_type == 'document' || reply_result[0].message_type == 'audio' || reply_result[0].message_type == 'video') {

                                                            reply_result[0].full_file_url = constant.chat_file + reply_result[0].file_url;
                                                        }
                                                        item.replied_message_detail = reply_result[0];
                                                        next();
                                                    } else {
                                                        item.replied_message_detail = {}
                                                        next(err);
                                                        return;
                                                    }
                                                })
                                            } else {
                                                item.replied_message_detail = {}
                                                next();
                                            }
                                        } else {
                                            next(message);
                                            return;
                                        }
                                    })
                                })
                            }, (_err) => {
                                if (_err) {
                                    callback(responseCode.OPERATION_FAILED, _err, null);
                                } else {
                                    callback(responseCode.SUCCESS, t('data_found'), result);
                                }
                            })
                        } else {
                            callback(responseCode.NO_DATA_FOUND, t('data_not_found'), null);
                        }
                    }
                    else {
                        callback(responseCode.OPERATION_FAILED, err, null);
                    }
                });
            } else {
                callback(responseCode.OPERATION_FAILED, _err, null);
            }
        });
    },

    /**
    * Function to get single message
    */

    getSingleLastMessage: (req, callback) => {
        con.query("SELECT * FROM tbl_chat_messages WHERE chat_room_id = '" + req.chat_room_id + "' order by id desc", (err, result) => {
            if (!err && result.length > 0) {
                if (result[0].message != '' && result[0].message != undefined) {
                    result[0].message = result[0].message.toString();
                    if (result[0].message_type == 'image' || result[0].message_type == 'document' || result[0].message_type == 'audio' || result[0].message_type == 'video') {
                        result[0].full_file_url = constant.chat_file + result[0].file_url;
                    }
                    if (result[0].message_type == 'video') {
                        result[0].thumbnail = constant.chat_file + result[0].thumbnail;
                    }
                    chat_model.get_sender_details({ sender_id: result[0].sender_id }, (code, message, data) => {
                        result[0].sender_detail = data;
                        if (result[0].is_reply == 1 || result[0].is_reply == '1') {
                            con.query("SELECT * FROM tbl_chat_messages WHERE id = '" + result[0].message_id + "'", (err, reply_result) => {
                                if (!err && reply_result.length > 0) {
                                    if (reply_result[0].message != '' && reply_result[0].message != undefined) {
                                        reply_result[0].message = reply_result[0].message.toString();
                                    } else {
                                        reply_result[0].message = '';
                                    }
                                    if (reply_result[0].message_type == 'video') {
                                        reply_result[0].thumbnail = constant.chat_file + reply_result[0].thumbnail;
                                    }
                                    if (reply_result[0].message_type == 'image' || reply_result[0].message_type == 'document' || reply_result[0].message_type == 'audio' || reply_result[0].message_type == 'video') {
                                        reply_result[0].full_file_url = constant.chat_file + reply_result[0].file_url;
                                    }
                                    result[0].replied_message_detail = reply_result[0];
                                } else {
                                    result[0].replied_message_detail = {}
                                }
                                callback(result[0]);
                            })
                        } else {
                            result[0].replied_message_detail = {}
                            callback(result[0]);
                        }
                        // callback(result[0]);
                    })
                } else {
                    result[0].message = '';
                    if (result[0].message_type == 'image' || result[0].message_type == 'document' || result[0].message_type == 'audio' || result[0].message_type == 'video') {
                        result[0].full_file_url = constant.chat_file + result[0].file_url;
                    }
                    if (result[0].message_type == 'video') {
                        result[0].thumbnail = constant.chat_file + result[0].thumbnail;
                    }
                    chat_model.get_sender_details({ sender_id: result[0].sender_id }, (code, message, data) => {
                        result[0].sender_detail = data;
                        if (result[0].is_reply == 1 || result[0].is_reply == '1') {
                            con.query("SELECT * FROM tbl_chat_messages WHERE id = '" + result[0].message_id + "'", (err, reply_result) => {
                                if (!err && reply_result.length > 0) {
                                    if (reply_result[0].message != '' && reply_result[0].message != undefined) {
                                        reply_result[0].message = reply_result[0].message.toString();
                                    } else {
                                        reply_result[0].message = '';
                                    }
                                    if (reply_result[0].message_type == 'video') {
                                        reply_result[0].thumbnail = constant.chat_file + reply_result[0].thumbnail;
                                    }
                                    if (reply_result[0].message_type == 'image' || reply_result[0].message_type == 'document' || reply_result[0].message_type == 'audio' || reply_result[0].message_type == 'video') {
                                        reply_result[0].full_file_url = constant.chat_file + reply_result[0].file_url;
                                    }
                                    result[0].replied_message_detail = reply_result[0];
                                } else {
                                    result[0].replied_message_detail = {}
                                }
                                callback(result[0]);
                            })
                        } else {
                            result[0].replied_message_detail = {}
                            callback(result[0]);
                        }
                        // callback(result[0]);
                    })
                }
            } else {
                callback({});
            }
        });
    },
    /**
    * Function to get single message
    */
    getSingleMessage: (message_id, callback) => {
        // console.log("message_id", message_id)
        var sql = "SELECT * FROM tbl_chat_messages WHERE id = '" + message_id + "'";
        // console.log("sql", sql)
        con.query(sql, (err, result, fields) => {
            if (!err) {
                // console.log("object", result)
                if (result.length > 0) {
                    if (result[0].message != '' && result[0].message != undefined) {
                        result[0].message = result[0].message.toString();
                    } else {
                        result[0].message = '';
                    }
                    if (result[0].message_type == 'image' || result[0].message_type == 'document' || result[0].message_type == 'audio' || result[0].message_type == 'video') {
                        result[0].full_file_url = constant.chat_file + result[0].file_url;
                    }
                    if (result[0].message_type == 'video') {
                        result[0].thumbnail = constant.chat_file + result[0].thumbnail;
                    }
                    if (result[0].is_reply == 1 || result[0].is_reply == '1') {
                        con.query("SELECT * FROM tbl_chat_messages WHERE id = '" + result[0].message_id + "'", (err, reply_result) => {
                            if (!err && reply_result.length > 0) {
                                if (reply_result[0].message != '' && reply_result[0].message != undefined) {
                                    reply_result[0].message = reply_result[0].message.toString();
                                }
                                if (reply_result[0].message_type == 'video') {
                                    reply_result[0].thumbnail = constant.chat_file + reply_result[0].thumbnail;
                                }
                                if (reply_result[0].message_type == 'image' || reply_result[0].message_type == 'document' || reply_result[0].message_type == 'audio' || reply_result[0].message_type == 'video') {
                                    reply_result[0].full_file_url = constant.chat_file + reply_result[0].file_url;
                                }
                                result[0].replied_message_detail = reply_result[0];
                            } else {
                                result[0].replied_message_detail = {}
                            }
                            callback(result[0]);
                        })
                    } else {
                        result[0].replied_message_detail = {}
                        // console.log("REsult==========", result)
                        callback(result[0]);
                    }
                } else {
                    callback({});
                }

            } else {
                console.log("Errrrrrrr", err)
                callback({});
            }
        });
    },
    setLinks: (req, callback) => {
        if (req.links != undefined && req.links.length > 0) {
            asyncLoop(req.links, (item, next) => {
                var insert_data = {
                    chat_message_id: req.message_id,
                    link: item
                }
                var sql = "insert into tbl_chat_links set ?";
                con.query(sql, insert_data, (_err, _data) => {
                    next();
                })
            }, () => {
                callback({});
            })
        } else {
            callback({});
        }
    },
    updateLinks: (req, callback) => {
        var sql = "select * from tbl_chat_links where chat_message_id=?";
        con.query(sql, req.old_message_id, (_err, _data) => {
            if (_data.length > 0) {
                asyncLoop(_data, (item, next) => {
                    var insert_data = {
                        chat_message_id: req.message_id,
                        link: item.link
                    }
                    var sql = "insert into tbl_chat_links set ?";
                    con.query(sql, insert_data, (_err, _data) => {
                        next();
                    })
                }, () => {
                    callback({});
                })
            } else {
                callback({});
            }
        })
    },
    /** 
     * send message 
     */
    sendMessage: (req, callback) => {
        req.message = (req.message != undefined) ? req.message : '';
        req.message_type = (req.message_type != undefined) ? req.message_type : 'text';
        if (req.chat_room_id != undefined && (req.chat_room_id > 0 || req.chat_room_id != '0')) {
            con.query('select * from tbl_chat_room where id =?', req.chat_room_id, (_err, _chat_room_data) => {
                if (_err) {
                    callback(responseCode.OPERATION_FAILED, _err, null);
                } else {
                    var chatRoom = _chat_room_data[0];
                    if (req.is_forward != undefined && (req.is_forward == 1 || req.is_forward == '1')) {
                        chat_model.getSingleMessage(req.message_id, (_message) => {
                            if (_message.id != undefined) {
                                console.log("_message===============", _message)
                                var messageparams = {
                                    chat_room_id: req.chat_room_id,
                                    sender_id: req.sender_id,
                                    message_type: _message.message_type,
                                    device_type: _message.device_type,
                                };
                                if (_message.message_type == 'text') {
                                    messageparams['message'] = _message.message;
                                } else if (_message.message_type == 'contact') {
                                    messageparams['message'] = _message.message;
                                    messageparams['contact_name'] = _message.contact_name;
                                    messageparams['contact_profile'] = _message.contact_profile;
                                } else if (_message.message_type == 'location') {
                                    messageparams['latitude'] = (_message.latitude != undefined) ? _message.latitude : ''
                                    messageparams['longitude'] = (_message.longitude != undefined) ? _message.longitude : '';
                                    messageparams['location_name'] = (_message.location_name != undefined) ? _message.location_name : '';
                                } else if (_message.message_type == 'link') {
                                    messageparams['message'] = _message.message;
                                } else if (_message.message_type == 'audio') {
                                    messageparams['file_url'] = (_message.file_url != undefined) ? _message.file_url : '';

                                } else if (_message.message_type == 'video') {
                                    messageparams['file_url'] = (_message.file_url != undefined) ? _message.file_url : '';
                                    var thumb = _message.thumbnail.split('/');
                                    messageparams['thumbnail'] = (_message.thumbnail != undefined) ? thumb[thumb.length - 1] : '';

                                } else if (_message.message_type == 'document') {
                                    messageparams['file_url'] = (_message.file_url != undefined) ? _message.file_url : '';
                                    messageparams['document_page_title'] = (_message.document_page_title != undefined) ? _message.document_page_title : '';
                                    messageparams['document_page_count'] = (_message.document_page_count != undefined) ? _message.document_page_count : '';
                                } else if (_message.message_type == 'image') {
                                    messageparams['file_url'] = (_message.file_url != undefined) ? _message.file_url : '';
                                } else if (_message.message_type == 'payment' || _message.message_type == 'payment_request') {
                                    messageparams['amount'] = (_message.amount != undefined) ? _message.amount : '';
                                }
                                if (req.is_forward != undefined) {
                                    messageparams['is_forward'] = req.is_forward;
                                    messageparams['message_id'] = req.message_id;
                                }
                                if (req.is_reply != undefined) {
                                    messageparams['is_reply'] = req.is_reply;
                                    messageparams['message_id'] = req.message_id;
                                }
                                messageparams['message'] = _message.message;
                                con.query('INSERT INTO tbl_chat_messages SET ?', messageparams, (err1, result1, fields) => {
                                    if (!err1) {
                                        if (result1.affectedRows > 0) {
                                            var message_id = result1.insertId;
                                            chat_model.getSingleMessage(message_id, (messagedata, error) => {
                                                //Update the chat mater table update time
                                                con.query("UPDATE tbl_chat_room SET ? WHERE id = '" + req.chat_room_id + "'", { updated_at: moment().format("YYYY-MM-DD HH:mm:ss") });
                                                chat_model.get_receivers_details({ chat_room_id: req.chat_room_id, sender_id: req.sender_id }, (code, msg, user) => {
                                                    if (code == 1 || code == '1') {
                                                        chat_model.get_sender_details({ sender_id: req.sender_id }, (sendercode, msg, sender_user) => {
                                                            if (sendercode == 1 || sendercode == '1') {
                                                                messagedata.isGroupChat = chatRoom.isGroupChat
                                                                messagedata.chat_profile = constant.chat_file + chatRoom.profile_image
                                                                messagedata.chat_group_name = chatRoom.chat_name
                                                                messagedata.admin_can_send_message = chatRoom.admin_can_send_message
                                                                messagedata.hide_user_phone = chatRoom.hide_phone_users
                                                                if (_message.message_type == 'link') {
                                                                    chat_model.updateLinks({ message_id: message_id, old_message_id: req.message_id }, () => {
                                                                        callback(responseCode.SUCCESS, t('rest_keyword_send_msg_success'), {
                                                                            "messagedata": messagedata, "message_id": message_id, receiver_details: user, sender_details: sender_user, isGroupChat: chatRoom.isGroupChat
                                                                        });
                                                                    });
                                                                } else {
                                                                    callback(responseCode.SUCCESS, t('rest_keyword_send_msg_success'), {
                                                                        "messagedata": messagedata, "message_id": message_id, receiver_details: user, sender_details: sender_user, isGroupChat: chatRoom.isGroupChat
                                                                    });
                                                                }

                                                            } else {
                                                                callback(code, msg, null);
                                                            }
                                                        })
                                                    } else {
                                                        callback(code, msg, null);
                                                    }
                                                })
                                            });
                                        } else {
                                            callback(responseCode.NO_DATA_FOUND, t('rest_keyword_api_no_data'), null);
                                        }
                                    } else {
                                        callback(responseCode.OPERATION_FAILED, err1, null);
                                    }
                                });
                            } else {
                                console.log("message not found")
                            }
                        })
                    } else {
                        var messageparams = {
                            chat_room_id: req.chat_room_id,
                            sender_id: req.sender_id,
                            message_type: req.message_type,
                            device_type: req.device_type,
                        };
                        if (req.message_type == 'text') {
                            messageparams['message'] = req.message;
                        } else if (req.message_type == 'contact') {
                            messageparams['message'] = req.message;
                            messageparams['contact_name'] = req.contact_name;
                            messageparams['contact_profile'] = req.contact_profile;
                        } else if (req.message_type == 'location') {
                            messageparams['latitude'] = (req.latitude != undefined) ? req.latitude : ''
                            messageparams['longitude'] = (req.longitude != undefined) ? req.longitude : '';
                            messageparams['location_name'] = (req.location_name != undefined) ? req.location_name : '';
                        } else if (req.message_type == 'link') {
                            messageparams['message'] = req.message;
                        } else if (req.message_type == 'audio') {
                            messageparams['file_url'] = (req.file_name != undefined) ? req.file_name : '';

                        } else if (req.message_type == 'video') {
                            messageparams['file_url'] = (req.file_name != undefined) ? req.file_name : '';
                            messageparams['thumbnail'] = (req.thumbnail != undefined) ? req.thumbnail : '';

                        } else if (req.message_type == 'document') {
                            messageparams['file_url'] = (req.file_name != undefined) ? req.file_name : '';
                            messageparams['document_page_title'] = (req.document_page_title != undefined) ? req.document_page_title : '';
                            messageparams['document_page_count'] = (req.document_page_count != undefined) ? req.document_page_count : '';

                        } else if (req.message_type == 'image') {
                            messageparams['file_url'] = (req.file_name != undefined) ? req.file_name : '';
                        } else if (req.message_type == 'payment' || req.message_type == 'payment_request') {
                            messageparams['amount'] = (req.amount != undefined) ? req.amount : '';
                        }
                        if (req.is_forward != undefined) {
                            messageparams['is_forward'] = req.is_forward;
                            messageparams['message_id'] = req.message_id;
                        }
                        if (req.is_reply != undefined) {
                            messageparams['is_reply'] = req.is_reply;
                            messageparams['message_id'] = req.message_id;
                        }
                        messageparams['message'] = req.message;
                        con.query('INSERT INTO tbl_chat_messages SET ?', messageparams, (err1, result1, fields) => {
                            if (!err1) {
                                if (result1.affectedRows > 0) {
                                    var message_id = result1.insertId;
                                    chat_model.getSingleMessage(message_id, (messagedata, error) => {
                                        //Update the chat mater table update time
                                        con.query("UPDATE tbl_chat_room SET ? WHERE id = '" + req.chat_room_id + "'", { updated_at: moment().format("YYYY-MM-DD HH:mm:ss") });
                                        chat_model.get_receivers_details({ chat_room_id: req.chat_room_id, sender_id: req.sender_id }, (code, msg, user) => {
                                            if (code == 1 || code == '1') {
                                                chat_model.get_sender_details({ sender_id: req.sender_id }, (sendercode, msg, sender_user) => {
                                                    if (sendercode == 1 || sendercode == '1') {
                                                        messagedata.isGroupChat = chatRoom.isGroupChat
                                                        messagedata.chat_profile = constant.chat_file + chatRoom.profile_image
                                                        messagedata.chat_group_name = chatRoom.chat_name
                                                        messagedata.admin_can_send_message = chatRoom.admin_can_send_message
                                                        messagedata.hide_user_phone = chatRoom.hide_phone_users
                                                        if (req.message_type == 'link') {
                                                            chat_model.setLinks({ message_id: message_id, links: req.links }, () => {
                                                                callback(responseCode.SUCCESS, t('rest_keyword_send_msg_success'), {
                                                                    "messagedata": messagedata, "message_id": message_id, receiver_details: user, sender_details: sender_user, isGroupChat: chatRoom.isGroupChat
                                                                });
                                                            });
                                                        } else {
                                                            callback(responseCode.SUCCESS, t('rest_keyword_send_msg_success'), {
                                                                "messagedata": messagedata, "message_id": message_id, receiver_details: user, sender_details: sender_user, isGroupChat: chatRoom.isGroupChat
                                                            });
                                                        }
                                                        // callback(responseCode.SUCCESS, t('rest_keyword_send_msg_success'), {
                                                        //     "messagedata": messagedata, "message_id": message_id, receiver_details: user, sender_details: sender_user, isGroupChat: chatRoom.isGroupChat
                                                        // });
                                                    } else {
                                                        callback(code, msg, null);
                                                    }
                                                })
                                            } else {
                                                callback(code, msg, null);
                                            }
                                        })
                                    });
                                } else {
                                    callback(responseCode.NO_DATA_FOUND, t('rest_keyword_api_no_data'), null);
                                }
                            } else {
                                callback(responseCode.OPERATION_FAILED, err1, null);
                            }
                        });
                    }
                }
            })
        } else {
            var query = "SELECT * FROM tbl_chat_room WHERE isGroupChat=0 and (user1 IN (" + req.sender_id + "," + req.receiver_id + ")) AND (user2 IN (" + req.receiver_id + ", " + req.sender_id + "))";
            con.query(query, (err, chat_room) => {
                if (!err && chat_room.length > 0) {
                    if (req.is_forward != undefined && (req.is_forward == 1 || req.is_forward == '1')) {
                        chat_model.getSingleMessage(req.message_id, (_message) => {
                            var messageparams = {
                                chat_room_id: req.chat_room_id,
                                sender_id: req.sender_id,
                                message_type: _message.message_type,
                                device_type: _message.device_type,
                            };
                            if (_message.message_type == 'text') {
                                messageparams['message'] = _message.message;
                            } else if (_message.message_type == 'contact') {
                                messageparams['message'] = _message.message;
                                messageparams['contact_name'] = _message.contact_name;
                                messageparams['contact_profile'] = _message.contact_profile;
                            } else if (_message.message_type == 'location') {
                                messageparams['latitude'] = (_message.latitude != undefined) ? _message.latitude : ''
                                messageparams['longitude'] = (_message.longitude != undefined) ? _message.longitude : '';
                                messageparams['location_name'] = (_message.location_name != undefined) ? _message.location_name : '';
                            } else if (_message.message_type == 'link') {
                                messageparams['message'] = _message.message;
                            } else if (_message.message_type == 'audio') {
                                messageparams['file_url'] = (_message.file_url != undefined) ? _message.file_url : '';
                            } else if (_message.message_type == 'video') {
                                messageparams['file_url'] = (_message.file_url != undefined) ? _message.file_url : '';
                                var thumb = _message.thumbnail.split('/');
                                messageparams['thumbnail'] = (_message.thumbnail != undefined) ? thumb[thumb.length - 1] : '';

                            } else if (_message.message_type == 'document') {
                                messageparams['file_url'] = (_message.file_url != undefined) ? _message.file_url : '';
                                messageparams['document_page_title'] = (_message.document_page_title != undefined) ? _message.document_page_title : '';
                                messageparams['document_page_count'] = (_message.document_page_count != undefined) ? _message.document_page_count : '';

                            } else if (_message.message_type == 'image') {
                                messageparams['file_url'] = (_message.file_url != undefined) ? _message.file_url : '';
                            } else if (messageparams.message_type == 'payment' || messageparams.message_type == 'payment_request') {
                                messageparams['amount'] = (messageparams.amount != undefined) ? messageparams.amount : '';
                            }
                            if (req.is_forward != undefined) {
                                messageparams['is_forward'] = req.is_forward;
                                messageparams['message_id'] = req.message_id;
                            }
                            if (req.is_reply != undefined) {
                                messageparams['is_reply'] = req.is_reply;
                                messageparams['message_id'] = req.message_id;
                            }
                            messageparams['message'] = _message.message;
                            con.query('INSERT INTO tbl_chat_messages SET ?', messageparams, (err1, result1, fields) => {
                                if (!err1) {
                                    if (result1.affectedRows > 0) {
                                        var message_id = result1.insertId;
                                        chat_model.getSingleMessage(message_id, (messagedata, error) => {
                                            //Update the chat mater table update time
                                            con.query("UPDATE tbl_chat_room SET ? WHERE id = '" + chat_room[0].id + "'", { updated_at: moment().format("YYYY-MM-DD HH:mm:ss") });
                                            chat_model.get_receivers_details({ chat_room_id: chat_room[0].id, sender_id: req.sender_id }, (code, msg, user) => {
                                                if (code == 1 || code == '1') {
                                                    chat_model.get_sender_details({ sender_id: req.sender_id }, (sendercode, msg, sender_user) => {
                                                        if (sendercode == 1 || sendercode == '1') {
                                                            messagedata.isGroupChat = chat_room[0].isGroupChat
                                                            messagedata.chat_profile = ""
                                                            messagedata.chat_group_name = ""
                                                            messagedata.admin_can_send_message = chat_room[0].admin_can_send_message
                                                            messagedata.hide_user_phone = chat_room[0].hide_phone_users
                                                            if (_message.message_type == 'link') {
                                                                chat_model.updateLinks({ message_id: message_id, old_message_id: req.message_id }, () => {
                                                                    callback(responseCode.SUCCESS, t('rest_keyword_send_msg_success'), {
                                                                        "messagedata": messagedata, "message_id": message_id, receiver_details: user, sender_details: sender_user, isGroupChat: chat_room[0].isGroupChat
                                                                    });
                                                                });
                                                            } else {
                                                                callback(responseCode.SUCCESS, t('rest_keyword_send_msg_success'), {
                                                                    "messagedata": messagedata, "message_id": message_id, receiver_details: user, sender_details: sender_user, isGroupChat: chat_room[0].isGroupChat
                                                                });
                                                            }
                                                            // callback(responseCode.SUCCESS, t('rest_keyword_send_msg_success'), {
                                                            //     "messagedata": messagedata, "message_id": message_id, receiver_details: user, sender_details: sender_user, isGroupChat: chat_room[0].isGroupChat
                                                            // });
                                                        } else {
                                                            callback(code, msg, null);
                                                        }
                                                    })
                                                } else {
                                                    callback(code, msg, null);
                                                }
                                            })
                                        });
                                    } else {
                                        callback(responseCode.NO_DATA_FOUND, t('rest_keyword_api_no_data'), null);
                                    }
                                } else {
                                    callback(responseCode.OPERATION_FAILED, err1, null);
                                }
                            });
                        });
                    } else {
                        if (req.is_forward != undefined && (req.is_forward == 1 || req.is_forward == '1')) {
                            chat_model.getSingleMessage(req.message_id, (_message) => {
                                var messageparams = {
                                    chat_room_id: req.chat_room_id,
                                    sender_id: req.sender_id,
                                    message_type: _message.message_type,
                                    device_type: _message.device_type,
                                };
                                if (_message.message_type == 'text') {
                                    messageparams['message'] = _message.message;
                                } else if (_message.message_type == 'contact') {
                                    messageparams['message'] = _message.message;
                                    messageparams['contact_name'] = _message.contact_name;
                                    messageparams['contact_profile'] = _message.contact_profile;
                                } else if (_message.message_type == 'location') {
                                    messageparams['latitude'] = (_message.latitude != undefined) ? _message.latitude : ''
                                    messageparams['longitude'] = (_message.longitude != undefined) ? _message.longitude : '';
                                    messageparams['location_name'] = (_message.location_name != undefined) ? _message.location_name : '';
                                } else if (_message.message_type == 'link') {
                                    messageparams['message'] = _message.message;
                                } else if (_message.message_type == 'audio') {
                                    messageparams['file_url'] = (_message.file_url != undefined) ? _message.file_url : '';
                                } else if (_message.message_type == 'video') {
                                    messageparams['file_url'] = (_message.file_url != undefined) ? _message.file_url : '';
                                    var thumb = _message.thumbnail.split('/');
                                    messageparams['thumbnail'] = (_message.thumbnail != undefined) ? thumb[thumb.length - 1] : '';
                                } else if (_message.message_type == 'document') {
                                    messageparams['file_url'] = (_message.file_url != undefined) ? _message.file_url : '';
                                    messageparams['document_page_title'] = (_message.document_page_title != undefined) ? _message.document_page_title : '';
                                    messageparams['document_page_count'] = (_message.document_page_count != undefined) ? _message.document_page_count : '';
                                } else if (_message.message_type == 'image') {
                                    messageparams['file_url'] = (_message.file_url != undefined) ? _message.file_url : '';
                                } else if (_message.message_type == 'payment' || _message.message_type == 'payment_request') {
                                    messageparams['amount'] = (_message.amount != undefined) ? _message.amount : '';
                                }
                                if (req.is_forward != undefined) {
                                    messageparams['is_forward'] = req.is_forward;
                                    messageparams['message_id'] = req.message_id;
                                }
                                if (req.is_reply != undefined) {
                                    messageparams['is_reply'] = req.is_reply;
                                    messageparams['message_id'] = req.message_id;
                                }
                                messageparams['message'] = _message.message;
                                con.query('INSERT INTO tbl_chat_messages SET ?', messageparams, (err1, result1, fields) => {
                                    if (!err1) {
                                        if (result1.affectedRows > 0) {
                                            var message_id = result1.insertId;
                                            chat_model.getSingleMessage(message_id, (messagedata, error) => {
                                                //Update the chat mater table update time
                                                con.query("UPDATE tbl_chat_room SET ? WHERE id = '" + chat_room[0].id + "'", { updated_at: moment().format("YYYY-MM-DD HH:mm:ss") });
                                                chat_model.get_receivers_details({ chat_room_id: chat_room[0].id, sender_id: req.sender_id }, (code, msg, user) => {
                                                    if (code == 1 || code == '1') {
                                                        chat_model.get_sender_details({ sender_id: req.sender_id }, (sendercode, msg, sender_user) => {
                                                            if (sendercode == 1 || sendercode == '1') {
                                                                messagedata.isGroupChat = chat_room[0].isGroupChat
                                                                messagedata.chat_profile = ""
                                                                messagedata.chat_group_name = ""
                                                                messagedata.admin_can_send_message = chat_room[0].admin_can_send_message
                                                                messagedata.hide_user_phone = chat_room[0].hide_phone_users
                                                                if (_message.message_type == 'link') {
                                                                    chat_model.updateLinks({ message_id: message_id, old_message_id: req.message_id }, () => {
                                                                        callback(responseCode.SUCCESS, t('rest_keyword_send_msg_success'), {
                                                                            "messagedata": messagedata, "message_id": message_id, receiver_details: user, sender_details: sender_user, isGroupChat: chat_room[0].isGroupChat
                                                                        });
                                                                    });
                                                                } else {
                                                                    callback(responseCode.SUCCESS, t('rest_keyword_send_msg_success'), {
                                                                        "messagedata": messagedata, "message_id": message_id, receiver_details: user, sender_details: sender_user, isGroupChat: chat_room[0].isGroupChat
                                                                    });
                                                                }
                                                                // callback(responseCode.SUCCESS, t('rest_keyword_send_msg_success'), {
                                                                //     "messagedata": messagedata, "message_id": message_id, receiver_details: user, sender_details: sender_user, isGroupChat: chat_room[0].isGroupChat
                                                                // });
                                                            } else {
                                                                callback(code, msg, null);
                                                            }
                                                        })
                                                    } else {
                                                        callback(code, msg, null);
                                                    }
                                                })
                                            });
                                        } else {
                                            callback(responseCode.NO_DATA_FOUND, t('rest_keyword_api_no_data'), null);
                                        }
                                    } else {
                                        callback(responseCode.OPERATION_FAILED, err1, null);
                                    }
                                });
                            });
                        } else {
                            var messageparams = {
                                chat_room_id: chat_room[0].id,
                                sender_id: req.sender_id,
                                message_type: req.message_type,
                                device_type: req.device_type,
                            };
                            if (req.message_type == 'text') {
                                messageparams['message'] = req.message;
                            } else if (req.message_type == 'contact') {
                                messageparams['message'] = req.message;
                                messageparams['contact_name'] = req.contact_name;
                                messageparams['contact_profile'] = req.contact_profile;
                            } else if (req.message_type == 'location') {
                                messageparams['latitude'] = (req.latitude != undefined) ? req.latitude : ''
                                messageparams['longitude'] = (req.longitude != undefined) ? req.longitude : '';
                                messageparams['location_name'] = (req.location_name != undefined) ? req.location_name : '';
                            } else if (req.message_type == 'link') {
                                messageparams['message'] = req.message;
                            } else if (req.message_type == 'audio') {
                                messageparams['file_url'] = (req.file_name != undefined) ? req.file_name : '';
                            } else if (req.message_type == 'video') {
                                messageparams['file_url'] = (req.file_name != undefined) ? req.file_name : '';
                                messageparams['thumbnail'] = (req.thumbnail != undefined) ? req.thumbnail : '';
                            } else if (req.message_type == 'document') {
                                messageparams['file_url'] = (req.file_name != undefined) ? req.file_name : '';
                                messageparams['document_page_title'] = (req.document_page_title != undefined) ? req.document_page_title : '';
                                messageparams['document_page_count'] = (req.document_page_count != undefined) ? req.document_page_count : '';
                            } else if (req.message_type == 'image') {
                                messageparams['file_url'] = (req.file_name != undefined) ? req.file_name : '';
                            } else if (messageparams.message_type == 'payment' || messageparams.message_type == 'payment_request') {
                                messageparams['amount'] = req.amount;
                            }
                            if (req.is_forward != undefined) {
                                messageparams['is_forward'] = req.is_forward;
                                messageparams['message_id'] = req.message_id;
                            }
                            if (req.is_reply != undefined) {
                                messageparams['is_reply'] = req.is_reply;
                                messageparams['message_id'] = req.message_id;
                            }
                            messageparams['message'] = req.message;
                            con.query('INSERT INTO tbl_chat_messages SET ?', messageparams, (err1, result1, fields) => {
                                if (!err1) {
                                    if (result1.affectedRows > 0) {
                                        var message_id = result1.insertId;
                                        chat_model.getSingleMessage(message_id, (messagedata, error) => {
                                            //Update the chat mater table update time
                                            con.query("UPDATE tbl_chat_room SET ? WHERE id = '" + chat_room[0].id + "'", { updated_at: moment().format("YYYY-MM-DD HH:mm:ss") });
                                            chat_model.get_receivers_details({ chat_room_id: chat_room[0].id, sender_id: req.sender_id }, (code, msg, user) => {
                                                if (code == 1 || code == '1') {
                                                    chat_model.get_sender_details({ sender_id: req.sender_id }, (sendercode, msg, sender_user) => {
                                                        if (sendercode == 1 || sendercode == '1') {
                                                            messagedata.isGroupChat = chat_room[0].isGroupChat
                                                            messagedata.chat_profile = ""
                                                            messagedata.chat_group_name = ""
                                                            messagedata.admin_can_send_message = chat_room[0].admin_can_send_message
                                                            messagedata.hide_user_phone = chat_room[0].hide_phone_users
                                                            if (req.message_type == 'link') {
                                                                chat_model.setLinks({ message_id: message_id, links: req.links }, () => {
                                                                    callback(responseCode.SUCCESS, t('rest_keyword_send_msg_success'), {
                                                                        "messagedata": messagedata, "message_id": message_id, receiver_details: user, sender_details: sender_user, isGroupChat: chat_room[0].isGroupChat
                                                                    });
                                                                });
                                                            } else {
                                                                callback(responseCode.SUCCESS, t('rest_keyword_send_msg_success'), {
                                                                    "messagedata": messagedata, "message_id": message_id, receiver_details: user, sender_details: sender_user, isGroupChat: chat_room[0].isGroupChat
                                                                });
                                                            }
                                                            // callback(responseCode.SUCCESS, t('rest_keyword_send_msg_success'), {
                                                            //     "messagedata": messagedata, "message_id": message_id, receiver_details: user, sender_details: sender_user, isGroupChat: chat_room[0].isGroupChat
                                                            // });
                                                        } else {
                                                            callback(code, msg, null);
                                                        }
                                                    })
                                                } else {
                                                    callback(code, msg, null);
                                                }
                                            })
                                        });
                                    } else {
                                        callback(responseCode.NO_DATA_FOUND, t('rest_keyword_api_no_data'), null);
                                    }
                                } else {
                                    callback(responseCode.OPERATION_FAILED, err1, null);
                                }
                            });
                        }
                    }
                } else {
                    var params = {
                        isGroupChat: 0,
                        user1: req.sender_id,
                        user2: req.receiver_id
                    }
                    con.query('INSERT INTO tbl_chat_room SET ?', [params], (err2, result2, fields) => {
                        if (!err2) {
                            if (result2.affectedRows > 0) {
                                var messageparams = {
                                    chat_room_id: result2.insertId,
                                    sender_id: req.sender_id,
                                    device_type: req.device_type,
                                };
                                messageparams['message_type'] = (req.message_type != undefined) ? req.message_type : '';
                                if (req.message_type == 'text') {
                                    messageparams['message'] = req.message;
                                } else if (req.message_type == 'contact') {
                                    messageparams['message'] = req.message;
                                    messageparams['contact_name'] = req.contact_name;
                                    messageparams['contact_profile'] = req.contact_profile;
                                } else if (req.message_type == 'location') {
                                    messageparams['latitude'] = (req.latitude != undefined) ? req.latitude : ''
                                    messageparams['longitude'] = (req.longitude != undefined) ? req.longitude : '';
                                    messageparams['location_name'] = (req.location_name != undefined) ? req.location_name : '';
                                } else if (req.message_type == 'link') {
                                    messageparams['message'] = req.message; h
                                } else if (req.message_type == 'audio') {
                                    messageparams['file_url'] = (req.file_name != undefined) ? req.file_name : '';
                                } else if (req.message_type == 'video') {
                                    messageparams['file_url'] = (req.file_name != undefined) ? req.file_name : '';
                                    messageparams['thumbnail'] = (req.thumbnail != undefined) ? req.thumbnail : '';
                                } else if (req.message_type == 'document') {
                                    messageparams['file_url'] = (req.file_name != undefined) ? req.file_name : '';
                                    messageparams['document_page_title'] = (req.document_page_title != undefined) ? req.document_page_title : '';
                                    messageparams['document_page_count'] = (req.document_page_count != undefined) ? req.document_page_count : '';
                                } else if (req.message_type == 'image') {
                                    messageparams['file_url'] = (req.file_name != undefined) ? req.file_name : '';
                                } else if (messageparams.message_type == 'payment' || messageparams.message_type == 'payment_request') {
                                    messageparams['amount'] = req.amount;
                                }
                                if (req.is_forward != undefined) {
                                    messageparams['is_forward'] = req.is_forward;
                                    messageparams['message_id'] = req.message_id;
                                }
                                if (req.is_reply != undefined) {
                                    messageparams['is_reply'] = req.is_reply;
                                    messageparams['message_id'] = req.message_id;
                                }
                                messageparams['message'] = (req.message != undefined) ? req.message : '';
                                con.query('INSERT INTO tbl_chat_messages SET ?', messageparams, (err3, result3, fields) => {
                                    if (!err3) {
                                        if (result3.affectedRows > 0) {
                                            var message_id = result3.insertId;
                                            chat_model.getSingleMessage(message_id, (messagedata, error) => {
                                                //Update the chat mater table update time
                                                con.query("UPDATE tbl_chat_room SET ? WHERE id = '" + result2.insertId + "'", { updated_at: moment().format("YYYY-MM-DD HH:mm:ss") });
                                                chat_model.get_receivers_details({ chat_room_id: result2.insertId, sender_id: req.sender_id }, (code, msg, user) => {
                                                    if (code == 1 || code == '1') {
                                                        chat_model.get_sender_details({ sender_id: req.sender_id }, (sendercode, msg, sender_user) => {
                                                            if (sendercode == 1 || sendercode == '1') {
                                                                messagedata.isGroupChat = 0
                                                                messagedata.chat_profile = ""
                                                                messagedata.chat_group_name = ""
                                                                messagedata.admin_can_send_message = 0
                                                                messagedata.hide_user_phone = 0
                                                                if (req.message_type == 'link') {
                                                                    chat_model.setLinks({ message_id: message_id, links: req.links }, () => {
                                                                        callback(responseCode.SUCCESS, t('rest_keyword_send_msg_success'), {
                                                                            "messagedata": messagedata, "message_id": message_id, receiver_details: user, sender_details: sender_user, isGroupChat: 0
                                                                        });
                                                                    });
                                                                } else {
                                                                    callback(responseCode.SUCCESS, t('rest_keyword_send_msg_success'), {
                                                                        "messagedata": messagedata, "message_id": message_id, receiver_details: user, sender_details: sender_user, isGroupChat: 0
                                                                    });
                                                                }
                                                                // callback(responseCode.SUCCESS, t('rest_keyword_send_msg_success'), {
                                                                //     "messagedata": messagedata, "message_id": message_id, receiver_details: user, sender_details: sender_user, isGroupChat: 0
                                                                // });
                                                            } else {
                                                                callback(code, msg, null);
                                                            }
                                                        })
                                                    } else {
                                                        callback(code, msg, null);
                                                    }
                                                })
                                            });
                                        } else {
                                            callback(responseCode.NO_DATA_FOUND, t('rest_keyword_api_no_data'), null);
                                        }
                                    } else {
                                        callback(responseCode.OPERATION_FAILED, err3, null);
                                    }
                                });
                            } else {
                                callback(responseCode.NO_DATA_FOUND, t('rest_keyword_api_no_data'), null);
                            }
                        } else {
                            callback(responseCode.OPERATION_FAILED, t('err2'), null);
                        }
                    });
                }
            });
        }
    },
    /**
    * Update group 
    */
    update_group: (req, callback) => {
        console.log("Update group api: ", req)
        var update_data = {
            chat_name: req.chat_name,
        };
        if (req.profile_image != undefined && req.profile_image != '') {
            update_data.profile_image = req.profile_image;
        } else {
            update_data.profile_image = '';
        }
        if (req.description != undefined && req.description != '') {
            update_data.description = req.description;
        }
        if (req.admin_can_send_message != undefined && req.admin_can_send_message != '') {
            update_data.admin_can_send_message = req.admin_can_send_message;
        }
        if (req.hide_phone_users != undefined && req.hide_phone_users != '') {
            update_data.hide_phone_users = req.hide_phone_users;
        }
        var sql = "update tbl_chat_room set ? where id=?";
        con.query(sql, [update_data, req.chat_room_id], (_err, _data) => {
            if (_err) {
                callback(responseCode.OPERATION_FAILED, _err, null);
            } else {
                var sql = "select * from tbl_chat_users where chat_room_id=? and is_delete!=1 and user_id!=?";
                con.query(sql, [req.chat_room_id, req.user_id], (_err, _res) => {
                    if (_err) {
                        callback(responseCode.OPERATION_FAILED, _err, null);
                    } else {
                        if (_res.length > 0) {
                            if (req.admin_can_send_message != undefined && req.admin_can_send_message != '') {

                                asyncLoop(_res, (item, next) => {
                                    var response_data = {
                                        admin_can_send_message: req.admin_can_send_message,
                                        chat_room_id: req.chat_room_id
                                    }
                                    var socket = global._unic_sokect_;
                                    if (global._unic_sokect_user[item.user_id] != undefined) {
                                        console.log('admin_can_send_message1111', response_data)
                                        socket.to(global._unic_sokect_user[item.user_id]['socket']).emit('admin_can_send_message', response_data);
                                        next();
                                    } else {
                                        var insert_data = {
                                            emit_type: 'admin_can_send_message',
                                            emit_to: item.user_id,
                                            emit_response: JSON.stringify(response_data)
                                        }
                                        console.log('admin_can_send_message2222', response_data)
                                        chat_model.store_emit(insert_data, (result) => {
                                            next();
                                        })
                                    }
                                })
                            }
                            if (req.hide_phone_users != undefined && req.hide_phone_users != '') {

                                asyncLoop(_res, (item, next) => {
                                    var response_data = {
                                        hide_phone_chat_room: req.hide_phone_users,
                                        chat_room_id: req.chat_room_id
                                    }
                                    var socket = global._unic_sokect_;
                                    if (global._unic_sokect_user[item.user_id] != undefined) {
                                        console.log('hide_phone_chat_room111', response_data)
                                        socket.to(global._unic_sokect_user[item.user_id]['socket']).emit('hide_phone_chat_room', response_data);
                                        next();
                                    } else {
                                        var insert_data = {
                                            emit_type: 'hide_phone_chat_room',
                                            emit_to: item.user_id,
                                            emit_response: JSON.stringify(response_data)
                                        }
                                        console.log('hide_phone_chat_room222', response_data)
                                        chat_model.store_emit(insert_data, (result) => {
                                            next();
                                        })
                                    }
                                })
                            }
                            callback(responseCode.SUCCESS, t('group_updated'), {});
                        } else {
                            callback(responseCode.SUCCESS, t('group_updated'), {});
                        }

                    }
                })

            }
        })
    },
    /**
    * add_user_in_group 
    */
    add_user_in_group: (req, callback) => {
        if (req.users.length > 0) {
            asyncLoop(req.users, (item, next) => {
                var sql = "select * from tbl_chat_users where user_id=? and chat_room_id=?";
                con.query(sql, [item, req.chat_room_id], (_err, _res) => {
                    if (!_err) {
                        if (_res.length > 0) {
                            next();
                        } else {
                            var insert = {
                                chat_room_id: req.chat_room_id,
                                user_id: item,
                                is_admin: 0
                            }
                            var sql = "insert into tbl_chat_users set ?";
                            con.query(sql, insert, (_err, _data) => {
                                if (_err) {
                                    next(_err);
                                    return;
                                } else {
                                    chat_model.clear_chat(insert, (code, message, data) => {
                                        next();
                                    })
                                }
                            })
                        }
                    } else {
                        next(_err);
                        return;
                    }
                })

            }, (err) => {
                if (err) {
                    callback(responseCode.OPERATION_FAILED, err, null);
                } else {
                    var sql = "SELECT tu.id as user_id, tu.name,tu.country_code,tu.phone,tcu.is_admin,tu.text_notification,IF( tu.profile_image !='', concat('" + constant.profile_image + "','',tu.profile_image), '' ) as profile_image,IF( tu.chat_wallpaper !='', concat('" + constant.chat_wallpaper + "','',tu.chat_wallpaper), '' ) as chat_wallpaper,qrcode_image FROM tbl_users AS tu join tbl_chat_users as tcu on tu.id=tcu.user_id WHERE tu.id in (" + req.users + ") and tcu.chat_room_id='" + req.chat_room_id + "' GROUP BY tu.id ";
                    con.query(sql, (_err, _data) => {
                        if (_err) {
                            callback(responseCode.OPERATION_FAILED, _err, null);
                        } else {
                            var sql = "select *,id as chat_room_id,IF(profile_image !='', concat('" + constant.chat_file + "','',profile_image), '' ) as profile_image from tbl_chat_room where id=?";
                            con.query(sql, req.chat_room_id, (_err, _chat_room) => {
                                if (_err) {
                                    callback(responseCode.OPERATION_FAILED, _err, null);
                                } else {
                                    var chat_room = _chat_room[0];
                                    var sql = "SELECT tu.id as user_id, tu.name,tu.country_code,tu.phone,tu.text_notification,IF( tu.profile_image !='', concat('" + constant.profile_image + "','',tu.profile_image), '' ) as profile_image,IF( tu.chat_wallpaper !='', concat('" + constant.chat_wallpaper + "','',tu.chat_wallpaper), '' ) as chat_wallpaper,qrcode_image FROM tbl_users AS tu WHERE tu.id=? ";
                                    con.query(sql, req.user_id, (_err, _admin_detail) => {
                                        asyncLoop(_data, (item, next) => {
                                            var response_data = {
                                                chat_room_id: req.chat_room_id,
                                                chat_profile: constant.chat_file + chat_room.profile_image,
                                                chat_group_name: chat_room.chat_name,
                                                admin_can_send_message: chat_room.admin_can_send_message,
                                                hide_phone_users: chat_room.hide_phone_users,
                                                admin_detail: _admin_detail[0],
                                            }
                                            console.log("you_added_in_group", response_data)
                                            var socket = global._unic_sokect_;
                                            if (global._unic_sokect_user[item.user_id] != undefined) {
                                                socket.to(global._unic_sokect_user[item.user_id]['socket']).emit('you_added_in_group', response_data);
                                                next();
                                            } else {
                                                var insert_data = {
                                                    emit_type: 'you_added_in_group',
                                                    emit_to: item.user_id,
                                                    emit_response: JSON.stringify(response_data)
                                                };
                                                chat_model.store_emit(insert_data, (result) => {
                                                    next();
                                                })
                                            }
                                        }, () => {
                                            console.log("response _data============", _data)
                                            callback(responseCode.SUCCESS, t('user_added_group'), _data);
                                        })
                                    })
                                }
                            })


                        }
                    })
                }

            })
        } else {
            callback(responseCode.OPERATION_FAILED, 'Plese select atleast one user.', null);
        }
    },
    /**
    * make_admin
    */
    make_admin: (req, callback) => {
        var sql = 'update tbl_chat_users set ? where chat_room_id=? and user_id=?';
        con.query(sql, [{ is_admin: 1 }, req.chat_room_id, req.group_user_id], (_err, _data) => {
            if (_err) {
                callback(responseCode.OPERATION_FAILED, _err, null);
            } else {
                callback(responseCode.SUCCESS, t('group_updated'), {});
            }
        })
    },
    /**
    * remove_user 
    */
    remove_user: (req, callback) => {
        var sql = 'delete from tbl_chat_users where chat_room_id=? and user_id=?';
        con.query(sql, [req.chat_room_id, req.group_user_id], (_err, _data) => {
            if (_err) {
                callback(responseCode.OPERATION_FAILED, _err, null);
            } else {
                var response_data = {
                    chat_room_id: req.chat_room_id,
                    deleted_by: req.user_id
                }
                var socket = global._unic_sokect_;
                if (global._unic_sokect_user[req.group_user_id] != undefined) {
                    socket.to(global._unic_sokect_user[req.group_user_id]['socket']).emit('you_removed_from_group', response_data);
                    callback(responseCode.SUCCESS, t('user_removed'), {});
                } else {
                    var insert_data = {
                        emit_type: 'you_removed_from_group',
                        emit_to: req.group_user_id,
                        emit_response: JSON.stringify(response_data)
                    };
                    chat_model.store_emit(insert_data, (result) => {
                        callback(responseCode.SUCCESS, t('user_removed'), {});
                    })
                }

            }
        })
    },
    /**
    * delete_group 
    */
    delete_group: (req, callback) => {
        var sql = "select * from tbl_chat_users where chat_room_id=? and user_id!=?"
        con.query(sql, [req.chat_room_id, req.user_id], (_err, _res) => {
            if (_err) {
                callback(responseCode.OPERATION_FAILED, _err, null);
            } else {
                if (_res.length > 0) {
                    asyncLoop(_res, (item, next) => {
                        chat_model.get_sender_details({ sender_id: req.user_id }, (code, msg, data) => {
                            var response_data = {
                                chat_room_id: req.chat_room_id,
                                deleted_by: data[0],
                                deleted_group: 'group_admin',
                            }
                            var socket = global._unic_sokect_;
                            if (global._unic_sokect_user[item.user_id] != undefined) {
                                socket.to(global._unic_sokect_user[item.user_id]['socket']).emit('delete_group', response_data);
                                next();
                            } else {
                                var insert_data = {
                                    emit_type: 'delete_group',
                                    emit_to: item.user_id,
                                    emit_response: JSON.stringify(response_data)
                                }
                                chat_model.store_emit(insert_data, (result) => {
                                    common.get_user_data(item.user_id, (err, user) => {
                                        if (err != undefined) {
                                            next();
                                        } else {
                                            if (user.id != undefined && (user.text_notification == 1 || user.text_notification == '1')) {
                                                var message_data = {
                                                    device_token: user.device_token,
                                                    device_type: user.device_type,
                                                    title: 'Group Delete',
                                                    message: 'Your group has been deleted',
                                                    tag: 'delete_group',
                                                    image_url: '',
                                                    chat_room_id: response_data.chat_room_id
                                                };
                                                notiLibrary.sendOrderpush(user.device_token, message_data, (status) => {
                                                    next();
                                                })
                                            } else {
                                                next();
                                            }
                                        }
                                    })
                                })
                            }
                        })
                    }, () => {
                        var sql = 'delete from tbl_chat_users where chat_room_id=?';
                        con.query(sql, req.chat_room_id, (_err, _data) => {
                            if (_err) {
                                callback(responseCode.OPERATION_FAILED, _err, null);
                            } else {
                                con.query('delete from tbl_chat_room where id=?', req.chat_room_id, (_err, _data) => {
                                    if (_err) {
                                        callback(responseCode.OPERATION_FAILED, _err, null);
                                    } else {
                                        callback(responseCode.SUCCESS, t('group_removed'), {});
                                    }
                                })
                            }
                        })
                    })
                } else {
                    callback(responseCode.NO_DATA_FOUND, t('data_not_found'), {});
                }
            }
        })


    },
    /**
    * delete_group 
    */
    delete_conversation: (req, callback) => {
        con.query('delete from tbl_chat_room where id=?', req.chat_room_id, (_err, _data) => {
            if (_err) {
                callback(responseCode.OPERATION_FAILED, _err, null);
            } else {
                callback(responseCode.SUCCESS, t('delete_conversation'), {});

            }
        })
    },
    /**
    * clear_chat 
    */
    clear_chat: (req, callback) => {
        // console.log("clear_chat", req);
        var sql = "select * from tbl_chat_clear where user_id=? and chat_room_id=?";
        con.query(sql, [req.user_id, req.chat_room_id], (_err, _data) => {
            if (_err) {
                callback(responseCode.OPERATION_FAILED, _err, null);
            } else {
                if (_data.length > 0) {
                    var insert_data = {
                        // clear_date: moment().format("YYYY-MM-DD HH:mm:ss")
                        clear_date: new Date().toISOString().replace(/T/, ' ').replace(/\..+/, '')
                    }
                    var sql = 'update tbl_chat_clear set ? where id=?';
                    con.query(sql, [insert_data, _data[0].id], (_err, _data) => {
                        if (_err) {
                            callback(responseCode.OPERATION_FAILED, _err, null);
                        } else {
                            callback(responseCode.SUCCESS, t('chat_cleard'), {});
                        }
                    })
                } else {
                    var insert_data = {
                        user_id: req.user_id,
                        chat_room_id: req.chat_room_id,
                        // clear_date: moment().format("YYYY-MM-DD HH:mm:ss")
                        clear_date: new Date().toISOString().replace(/T/, ' ').replace(/\..+/, '')
                    }
                    var sql = 'insert into tbl_chat_clear set ?';
                    con.query(sql, insert_data, (_err, _data) => {
                        if (_err) {
                            callback(responseCode.OPERATION_FAILED, _err, null);
                        } else {
                            callback(responseCode.SUCCESS, t('chat_cleard'), {});
                        }
                    })
                }
            }
        })
    },
    /**
    * group deatil 
    */
    chat_room_detail: (req, callback) => {
        var sql = "select *,id as chat_room_id,IF(profile_image !='', concat('" + constant.chat_file + "','',profile_image), '' ) as profile_image from tbl_chat_room where id=?";
        con.query(sql, req.chat_room_id, (_err, _chat_room) => {
            if (_err) {
                callback(responseCode.OPERATION_FAILED, _err, null)
            } else {
                if (_chat_room.length > 0) {
                    var chat_room = _chat_room[0];
                    if (chat_room.isGroupChat == 1) {
                        var sql = "SELECT tu.id as user_id, tu.name,tu.country_code,tu.phone,tcu.is_admin,tu.text_notification,tu.is_business,IF( tu.profile_image !='', concat('" + constant.profile_image + "','',tu.profile_image), '' ) as profile_image,IF( tu.chat_wallpaper !='', concat('" + constant.chat_wallpaper + "','',tu.chat_wallpaper), '' ) as chat_wallpaper,tu.qrcode_image,tu.chat_status FROM tbl_users AS tu left join tbl_chat_users as tcu on tu.id=tcu.user_id WHERE tcu.chat_room_id='" + chat_room.id + "' and tcu.is_delete!=1 order by tcu.is_admin desc "
                        con.query(sql, (_err, _users) => {
                            if (_err) {
                                callback(responseCode.OPERATION_FAILED, _err, null)
                            } else {

                                asyncLoop(_users, (item, next) => {
                                    var data = {
                                        sender_id: req.user_id,
                                        receiver_id: item.user_id
                                    }
                                    chat_model.get_single_chat_room(data, (code, message, res_data) => {
                                        if (code == 1 || code == '1') {
                                            item.chat_room_id = res_data.id;
                                        } else {
                                            item.chat_room_id = '';
                                        }
                                        common.check_block({ user1: req.user_id, user2: item.user_id }, (resp) => {
                                            item.are_you_blocked = resp.are_you_blocked
                                            item.is_blocked_by_you = resp.is_blocked_by_you
                                            next();
                                        })
                                    })
                                }, () => {
                                    console.log(_users)
                                    chat_room.users = _users;
                                    chat_model.get_media_data({ chat_room_id: chat_room.id, user_id: req.user_id }, (code, msg, media_res) => {
                                        if (code == 1 || code == '1') {
                                            chat_room.media = media_res.dm
                                            chat_room.docs = media_res.dds
                                            chat_room.links = media_res.dl
                                        } else {
                                            chat_room.media = []
                                            chat_room.docs = []
                                            chat_room.links = []
                                        }
                                        chat_model.get_sender_details({ sender_id: chat_room.created_by }, (code, msg, data) => {
                                            chat_room.created_by_detail = data[0];
                                            callback(responseCode.SUCCESS, t('data_found'), chat_room);
                                        })
                                    })
                                })
                            }
                        })
                    } else {
                        var sql = "SELECT tu.id as user_id, tu.name,tu.country_code,tu.phone,tu.text_notification,tu.is_business,IF( tu.profile_image !='', concat('" + constant.profile_image + "','',tu.profile_image), '' ) as profile_image,IF( tu.chat_wallpaper !='', concat('" + constant.chat_wallpaper + "','',tu.chat_wallpaper), '' ) as chat_wallpaper,tu.qrcode_image,tu.chat_status FROM tbl_users AS tu  WHERE tu.id=? or tu.id=?";
                        con.query(sql, [chat_room.user1, chat_room.user2], (_err, _users) => {
                            if (_err) {
                                callback(responseCode.OPERATION_FAILED, _err, null)
                            } else {
                                // console.log("_users", _users)
                                asyncLoop(_users, (item, next) => {
                                    // if (item.user_id == chat_room.user2) {
                                    common.check_block({ user1: req.user_id, user2: item.user_id }, (resp) => {
                                        item.are_you_blocked = resp.are_you_blocked
                                        item.is_blocked_by_you = resp.is_blocked_by_you
                                        next();
                                    })
                                    // } else {
                                    //     item.are_you_blocked = 0
                                    //     item.is_blocked_by_you = 0
                                    //     next();
                                    // }
                                }, () => {
                                    chat_room.users = _users;
                                    chat_model.get_media_data({ chat_room_id: chat_room.id, user_id: req.user_id }, (code, msg, media_res) => {
                                        if (code == 1 || code == '1') {
                                            chat_room.media = media_res.dm;
                                            chat_room.docs = media_res.dds;
                                            chat_room.links = media_res.dl;
                                        } else {
                                            chat_room.media = [];
                                            chat_room.docs = [];
                                            chat_room.links = [];
                                        }
                                        callback(responseCode.SUCCESS, t('data_found'), chat_room);
                                    })
                                })

                            }
                        })
                    }
                } else {
                    callback(responseCode.NO_DATA_FOUND, t('data_not_found'), {});
                }

            }
        })
    },
    /** 
     * Get chat room's media data
    */
    get_media_data: (req, callback) => {
        var media = [];
        var docs = [];
        var links = [];
        var sql = "select * from tbl_chat_clear where chat_room_id=? and user_id=?";
        con.query(sql, [req.chat_room_id, req.user_id], (_err, _data) => {
            if (_err) {
                callback(responseCode.OPERATION_FAILED, _err, null);
            } else {
                if (_data.length > 0) {
                    var sql = "select * from tbl_chat_messages where chat_room_id=? and message_type in ('image','document','video','link') and created_at > '" + moment(_data[0].clear_date).format('YYYY-MM-DD HH:mm:ss') + "' order by id desc";

                } else {
                    var sql = "select * from tbl_chat_messages where chat_room_id=? and message_type in ('image','document','video','link')  order by id desc";

                }
                con.query(sql, req.chat_room_id, (_err, _response_data) => {
                    if (_err) {
                        callback(responseCode.OPERATION_FAILED, _err, null);
                    } else {
                        if (_response_data.length > 0) {
                            asyncLoop(_response_data, (item, next) => {
                                if (item.message_type == 'image' || item.message_type == 'video') {
                                    media.push({ id: item.id, data: constant.chat_file + item.file_url, thumb_url: constant.chat_file + item.thumbnail, created_at: item.created_at, type: item.message_type });
                                    next();
                                } else if (item.message_type == 'document') {
                                    // console.log(item.created_at)
                                    docs.push({ id: item.id, data: constant.chat_file + item.file_url, created_at: item.created_at, type: item.message_type, document_page_title: item.document_page_title, document_page_count: item.document_page_count });
                                    next();
                                } else if (item.message_type == 'link') {
                                    if (_data.length > 0) {
                                        var sql = "select * from tbl_chat_links where chat_message_id=? and created_at > '" + moment(_data[0].clear_date).format('YYYY-MM-DD HH:mm:ss') + "' order by id desc";
                                    } else {
                                        var sql = "select * from tbl_chat_links where chat_message_id=?  order by id desc";

                                    }
                                    con.query(sql, item.id, (_err, _links) => {
                                        if (_links.length > 0) {
                                            asyncLoop(_links, (item1, next1) => {
                                                links.push({ id: item1.id, message_id: item.id, data: item1.link, created_at: item1.created_at, type: item.message_type });
                                                next1();
                                            }, () => {
                                                next();
                                            })
                                        } else {
                                            next();
                                        }
                                    })
                                }
                            }, () => {
                                callback(responseCode.SUCCESS, t('data_found'), { dm: media, dds: docs, dl: links })
                            })
                        } else {
                            callback(responseCode.SUCCESS, t('data_found'), { dm: media, dds: docs, dl: links })
                        }
                    }
                })
            }
        })


    },
    /**
     * Make/Removed Starred
     */
    remove_starred: (req, callback) => {
        asyncLoop(req.message_ids, (item, next) => {
            var sql = 'select * from tbl_chat_messages where id=?';
            con.query(sql, item, (_err, _message) => {
                if (_err) {
                    next(_err);
                    return;
                } else {
                    var message = _message[0];
                    con.query('delete from tbl_starred_message where chat_room_id=? and message_id=? and user_id=?', [message.chat_room_id, message.id, req.user_id], (_err, _delete) => {
                        if (_err) {
                            next(_err);
                            return;
                        } else {
                            next();
                        }
                    })
                }
            })
        }, (err) => {
            if (err) {
                callback(responseCode.OPERATION_FAILED, err, null);
            } else {
                callback(responseCode.SUCCESS, t('remove_starred_message'), {})
            }
        })
    },
    make_starred: (req, callback) => {
        asyncLoop(req.message_ids, (item, next) => {
            var sql = 'select * from tbl_chat_messages where id=?';
            con.query(sql, item, (_err, _message) => {
                if (_err) {
                    next(_err);
                    return;
                } else {
                    var message = _message[0];
                    var sql = `select * from tbl_starred_message where user_id=${req.user_id} and message_id=${item}`;
                    con.query(sql, (_err, _data) => {
                        if (_err) {
                            next(_err);
                            return;
                        } else {
                            if (_data.length > 0) {
                                next();
                            } else {
                                var insert_data = {
                                    user_id: req.user_id,
                                    message_id: req.message_id,
                                    chat_room_id: message.chat_room_id
                                }
                                var sql = `insert into tbl_starred_message set ?`;
                                con.query(sql, insert_data, (_err, _data) => {
                                    if (_err) {
                                        next(_err);
                                        return;
                                    } else {
                                        next();
                                    }
                                })
                            }
                        }
                    })
                }
            })
        }, (err) => {
            if (err) {
                callback(responseCode.OPERATION_FAILED, err, null);
            } else {
                callback(responseCode.SUCCESS, t('add_starred_message'), {})
            }
        })
    },
    /* 
    * Get Stared message list
    */
    starred_message_list: (req, callback) => {
        var sql = `select tsm.*,tcm.message_type,tcm.message,tcm.message as text_message,tcm.sender_id,tcm.amount,tcm.payment_status,tcm.sender_type,tcm.is_starred,tcm.is_forward,tcm.is_reply,tcm.file_url,tcm.thumbnail,tcm.latitude,tcm.longitude,tcm.location_name,tcm.document_page_title,tcm.document_page_count,tcm.contact_name,tcm.contact_profile from tbl_starred_message as tsm left join tbl_chat_messages as tcm on tcm.id=tsm.message_id where tsm.chat_room_id=? `;
        con.query(sql, req.chat_room_id, (_err, _data) => {
            if (_err) {
                callback(responseCode.OPERATION_FAILED, _err, null);
            } else {
                if (_data.length > 0) {
                    asyncLoop(_data, (item, next) => {
                        if (item.message != '' && item.message != undefined) {
                            item.message = item.message.toString();
                        } else {
                            item.message = '';
                        }
                        if (item.text_message != '' && item.text_message != undefined) {
                            item.text_message = item.text_message.toString();
                        } else {
                            item.text_message = '';
                        }
                        if (item.message_type == 'image' || item.message_type == 'document' || item.message_type == 'audio' || item.message_type == 'video') {
                            item.full_file_url = constant.chat_file + item.file_url;
                        }
                        if (item.message_type == 'video') {
                            item.thumbnail = constant.chat_file + item.thumbnail;
                        }
                        if (item.is_reply == 1 || item.is_reply == '1') {
                            con.query("SELECT * FROM tbl_chat_messages WHERE id = '" + item.message_id + "'", (err, reply_result) => {
                                if (!err && reply_result.length > 0) {
                                    if (reply_result[0].message != '' && reply_result[0].message != undefined) {
                                        reply_result[0].message = reply_result[0].message.toString();
                                    } else {
                                        reply_result[0].message = '';
                                    }
                                    if (reply_result[0].message_type == 'video') {
                                        reply_result[0].thumbnail = constant.chat_file + reply_result[0].thumbnail;
                                    }
                                    if (reply_result[0].message_type == 'image' || reply_result[0].message_type == 'document' || reply_result[0].message_type == 'audio' || reply_result[0].message_type == 'video') {
                                        reply_result[0].full_file_url = constant.chat_file + reply_result[0].file_url;
                                    }
                                    item.replied_message_detail = reply_result[0];
                                } else {
                                    item.replied_message_detail = {}
                                }
                                chat_model.get_sender_details({ sender_id: item.sender_id }, (code, message, data) => {
                                    item.sender_detail = data;
                                    next();
                                })
                            })
                        } else {
                            item.replied_message_detail = {}
                            // console.log("Result==========", result)
                            chat_model.get_sender_details({ sender_id: item.sender_id }, (code, message, data) => {
                                item.sender_detail = data;
                                next();
                            })
                        }
                    }, () => {
                        callback(responseCode.SUCCESS, t('data_found'), _data);
                    })
                } else {
                    callback(responseCode.NO_DATA_FOUND, t('data_not_found'), {})
                }
            }
        })
    },
    /** 
     * Delete message
     */
    delete_message: (req, callback) => {
        var sql = "select tcm.chat_room_id,tcm.id as message_id,tcm.sender_id as message_sender from tbl_chat_messages as tcm join tbl_chat_room as tcr on tcr.id=tcm.chat_room_id where tcm.id=?";
        con.query(sql, req.message_ids[0], (_err, _message) => {
            if (_err) {
                callback(callback(false, _err));
            } else {
                var message_detail = _message[0];
                chat_model.get_receivers_details({ chat_room_id: message_detail.chat_room_id, sender_id: req.user_id }, (code, msg, data) => {

                    if (data != undefined && data.length > 0) {
                        asyncLoop(req.message_ids, (item, next) => {
                            var sql = "delete from tbl_chat_messages where id=?";
                            con.query(sql, item, (_err, _data) => {
                                if (_err) {
                                    next(_err);
                                    return;
                                } else {
                                    next();
                                }
                            })
                        }, (_err) => {
                            if (_err) {
                                // console.log("delete_message", _err);
                                callback(false, _err)
                            } else {
                                callback(true, data)
                            }
                        })
                    } else {
                        callback(false, msg)
                    }
                })
            }
        })

    },
    /** 
     * Read Message
    */
    read_meesage: (req, callback) => {
        var message_detail = [];
        if (req.chat_room_id != undefined) {
            var sql = "select * from tbl_chat_messages where chat_room_id=? and is_read=0 and sender_id!=?";
            con.query(sql, [req.chat_room_id, req.user_id], (_err, _messages) => {
                if (_err) {
                    callback(responseCode.OPERATION_FAILED, _err, null);
                } else {
                    if (_messages.length > 0) {
                        asyncLoop(_messages, (item, next) => {
                            con.query(`update tbl_chat_messages set ? where id=?`, [{ is_read: 1 }, item.id], (_err, _updatedata) => {
                                if (_err) {
                                    next(_err);
                                    return;
                                } else {
                                    var insert_data = {
                                        chat_room_id: req.chat_room_id,
                                        user_id: req.user_id,
                                        message_id: item.id
                                    }
                                    var sql = `insert into tbl_chat_message_read_users set ?`;
                                    con.query(sql, insert_data, (_err, _inserted) => {
                                        if (_err) {
                                            next(_err);
                                            return;
                                        } else {
                                            message_detail.push({
                                                sender_id: item.sender_id,
                                                message_id: item.id
                                            });
                                            next();
                                        }
                                    })
                                }
                            })
                        }, (err) => {
                            if (err) {
                                callback(responseCode.OPERATION_FAILED, err, null);
                            } else {
                                callback(responseCode.SUCCESS, t('rest_keyword_message_read_success'), message_detail);

                            }
                        })
                    } else {
                        callback(responseCode.SUCCESS, t('rest_keyword_message_read_success'), message_detail);
                    }
                }
            })
        } else {
            var sql = "select tcm.chat_room_id,tcm.id as message_id,tcm.sender_id as message_sender from tbl_chat_messages as tcm join tbl_chat_room as tcr on tcr.id=tcm.chat_room_id where tcm.id=?";
            con.query(sql, req.message_id, (_err, _data) => {
                if (_err) {
                    callback(responseCode.OPERATION_FAILED, _err, null);
                } else {
                    if (_data.length > 0) {
                        con.query(`update tbl_chat_messages set ? where id=?`, [{ is_read: 1 }, req.message_id], (_err, _updatedata) => {
                            if (_err) {
                                callback(responseCode.OPERATION_FAILED, _err, null);
                            } else {
                                var insert_data = {
                                    chat_room_id: _data[0].chat_room_id,
                                    user_id: req.user_id,
                                    message_id: _data[0].message_id
                                }
                                var sql = `insert into tbl_chat_message_read_users set ?`;
                                con.query(sql, insert_data, (_err, _inserted) => {
                                    if (_err) {
                                        callback(responseCode.OPERATION_FAILED, _err, null);
                                    } else {
                                        callback(responseCode.SUCCESS, t('rest_keyword_message_read_success'), [{ sender_id: _data[0].message_sender, message_id: req.message_id }])
                                    }
                                })
                            }
                        })
                    } else {
                        callback(responseCode.NO_DATA_FOUND, t('data_not_found'), {})
                    }
                }
            })

        }
    },
    /* Message viewed user */
    message_viewed_user: (req, callback) => {
        var sql = "select tcm.chat_room_id,tcm.id as message_id,tcm.sender_id as message_sender from tbl_chat_messages as tcm join tbl_chat_room as tcr on tcr.id=tcm.chat_room_id where tcm.id=?";
        con.query(sql, req.message_id, (_err, _message) => {
            if (_err) {
                callback(responseCode.OPERATION_FAILED, _err, null);
            } else {
                var message_detail = _message[0];
                var response = {};
                chat_model.get_receivers_details({ chat_room_id: message_detail.chat_room_id, sender_id: req.user_id }, (code, msg, data) => {
                    var viewed_user = [];
                    var not_viewed_user = [];
                    asyncLoop(data, (item, next) => {
                        var sql = "select * from tbl_chat_message_read_users where message_id=? and user_id=?";
                        con.query(sql, [req.message_id, item.user_id], (_err, _user) => {
                            if (_err) {
                                next(_err);
                                return;
                            } else {
                                if (_user.length > 0) {
                                    viewed_user.push(item);
                                    next();
                                } else {
                                    not_viewed_user.push(item);
                                    next();
                                }
                            }
                        })
                    }, (err) => {
                        if (err) {
                            callback(responseCode.OPERATION_FAILED, err, null);
                        } else {
                            response.viewed_user = viewed_user;
                            response.not_viewed_user = not_viewed_user;
                            callback(responseCode.SUCCESS, t('data_found'), response);
                        }
                    })

                })
            }
        })
    },
    /* Store emit data in temp table */
    store_emit: (req, callback) => {
        var sql = `insert into tbl_chat_emit_temp set ?`;
        con.query(sql, req, (_err, _data) => {
            if (_err) {
                callback(false);
            } else {
                callback(true);
            }
        })
    },
    /* Get emit data from temp table */
    get_emit: (req, callback) => {
        var sql = `select * from tbl_chat_emit_temp where emit_to=?`;
        con.query(sql, req.user_id, (_err, _data) => {
            if (_err) {
                callback(_err, undefined);
            } else {
                callback(undefined, _data);
            }
        })
    },
    /* Delete emit data from temp table */
    delete_emit: (req, callback) => {
        var sql = `delete from tbl_chat_emit_temp where id=?`;
        con.query(sql, req.id, (_err, _data) => {
            if (_err) {
                // console.log(_err)
                callback(_err, undefined);
            } else {
                callback(undefined, _data);
            }
        })
    },
    /* send emit */
    send_emit: (req, callback) => {
        console.log("send_emit", req);
        var socket = global._unic_sokect_;
        if (global._unic_sokect_user[req.emit_user] != undefined) {
            socket.to(global._unic_sokect_user[req.emit_user]['socket']).emit(req.emit_type, req.emit_response);
            callback(responseCode.SUCCESS, t('emit has been send successfully'), {})
        } else {
            var insert_data = {
                emit_type: req.emit_type,
                emit_to: req.emit_user,
                emit_response: JSON.stringify(req.emit_response)
            }
            chat_model.store_emit(insert_data, (result) => {
                callback(responseCode.SUCCESS, t('emit has been send successfully'), {})

            })
        }
    },
    /* Decline Payement Request */
    decline_request: (req, callback) => {
        console.log("decline_request", req);
        var sql = "select * from tbl_chat_messages where id=?";
        con.query(sql, req.message_id, (_err, _message) => {
            if (_err) {
                callback(0, _err, null);
            } else {
                if (_message.length > 0) {
                    var update_data = {
                        payment_status: 'decline',
                        message_type: 'request_decline'
                    };
                    var sql = "update tbl_chat_messages set ? where id=?";
                    con.query(sql, [update_data, req.message_id], (_err, _update_msg) => {
                        if (_err) {
                            console.log("msg eeeee _err", _err);
                            callback(0, _err, null);
                        } else {
                            chat_model.get_receivers_details({ chat_room_id: _message[0].chat_room_id, sender_id: req.user_id }, (code, msg, user) => {
                                if (code == 1 || code == '1') {
                                    var data = {
                                        'chat_room_id': _message[0].chat_room_id,
                                        'user_details': user,
                                        'id': _message[0].id,
                                        'sender_id': _message[0].sender_id
                                    }
                                    callback(code, 'Payment Request has been declined successfully', data);
                                } else {
                                    console.log("msg eeeee", msg);
                                    callback(code, msg, null);
                                }
                            })
                        }
                    });
                } else {
                    callback(0, t('rest_keyword_message_went_wrong'), null);
                }
            }
        })
    }
};
module.exports = chat_model