var responseCode = require('../../../config/response-error-code');
var con = require('../../../config/database');
var constant = require('../../../config/constant');
var notiLibrary = require('../../../config/notification');
var common = require('../../../utilities/common');
var template = require('../../../utilities/template')
var { t } = require('localizify');
var md5 = require('md5');
var asyncLoop = require('node-async-loop');
var moment = require('moment');
var chat_model = require('./chat_model');
var user_model = require('./../user/user_model')
var live_stream_model = require('./../live_stream/live_stream_model')
var socket_model = {
    emitFunction: (io) => {
        var users = {};
        global._unic_sokect_user = {};
        var sock = io
            .of('/chat').use((socket, next) => {
                // console.log(socket);
                // let token = socket.handshake.query.token;
                return next();
            }).on('connection', function (socket) {
                let user_id;
                let user_type;
                user_id = socket.handshake.query.user_id;
                user_type = socket.handshake.query.user_type;
                console.log(user_id + ' (' + user_type + ') is connected')
                // console.log(user_type + ' is connected')
                var params =
                {
                    chat_status: "online"
                }
                //update user table
                con.query("UPDATE tbl_users SET ? WHERE id = '" + user_id + "'", params, function (err, result, fields) {
                });


                global._unic_sokect_user[user_id] = {
                    "socket": socket.id
                };
                users[user_id] = {
                    "socket": socket.id
                };
                console.log(users)
                // code for sending online user
                var response = { code: responseCode.SUCCESS, message: t('rest_keyword_message_user_online'), data: { user_id: user_id, user_type: user_type, chat_status: 'online' } };
                sock.to(users[user_id]['socket']).emit('live', response);
                socket.broadcast.emit('live', response);
                /* emit temp data */
                chat_model.get_emit({ user_id: user_id }, (err, result) => {
                    if (err) {
                        console.log("get_emit_app", err);
                    } else {
                        if (result.length > 0) {
                            asyncLoop(result, (item, next) => {
                                if (users[item.emit_to] != undefined) {
                                    sock.to(users[item.emit_to]['socket']).emit(item.emit_type, JSON.parse(item.emit_response));
                                    console.log("get_emit_app success");

                                    chat_model.delete_emit({ id: item.id }, (err, data) => {
                                        next();

                                    });
                                } else {
                                    next();

                                }
                            })
                        }
                    }
                })
                socket.on('send_message', function (request) {
                    console.log("request---send_message------->>>>>>>>>>>>>>>>>>>>>>>>>>>>>", request);
                    var receiver_id = request.receiver_id;
                    chat_model.sendMessage(request, function (code, message, res) {
                        // console.log("code", code)
                        // console.log("message", message)
                        if (code == 1 || code == '1') {
                            // console.log("res", res)
                            var result = res.messagedata;
                            var message_id = res.message_id;
                            var receiver_details = res.receiver_details;
                            var sender_details = res.sender_details;
                            if (result != undefined) {
                                request.original_sender_id = request.sender_id;
                                if (request.sender_local_db_id != undefined) {
                                    result.sender_local_db_id = request.sender_local_db_id;
                                }
                                if (request.local_date != undefined) {
                                    result.local_date = request.local_date;
                                }
                                if (request.device_type != undefined) {
                                    result.device_type = request.device_type;
                                }
                                if (receiver_details.length > 0) {
                                    result.sender_detail = sender_details;
                                    var response_data = { code: responseCode.SUCCESS, message: t('rest_keyword_message_receive_success'), data: result };
                                    /* async loop */
                                    asyncLoop(receiver_details, (item, next) => {
                                        common.get_user_data(item.user_id, (err, user) => {
                                            console.log("user.id ", user.id)
                                            if (user.id != undefined && (user.text_notification == 1 || user.text_notification == '1')) {
                                                var message_data = {
                                                    device_token: user.device_token,
                                                    device_type: user.device_type,
                                                    title: 'Receive Message',
                                                    message: 'You have new message',
                                                    tag: 'send_message',
                                                    image_url: '',
                                                    chat_room_id: response_data.data.chat_room_id,
                                                    message_id: response_data.data.id,
                                                    isGroupChat: response_data.data.isGroupChat,
                                                    sender_name: sender_details[0].name,
                                                    sender_id: sender_details[0].user_id,
                                                    sender_phone: sender_details[0].country_code + sender_details[0].phone,
                                                    admin_can_send_message: response_data.data.admin_can_send_message,
                                                    hide_user_phone: response_data.data.hide_user_phone
                                                };
                                                if (response_data.data.isGroupChat == 1 && response_data.data.isGroupChat == '1') {
                                                    message_data.chat_profile = response_data.data.chat_profile;
                                                    message_data.chat_group_name = response_data.data.chat_group_name;
                                                } else {
                                                    message_data.chat_profile = sender_details[0].profile_image;
                                                }
                                                notiLibrary.sendOrderpush(user.device_token, message_data, (status) => {
                                                    chat_model.get_unread_count({ chat_room_id: result.chat_room_id, user_id: item.user_id }, (count) => {
                                                        response_data.data.unread_count = count;
                                                        if (users[item.user_id] != undefined) {
                                                            // var response_data = { data: result, message: t['rest_keyword_message_receive_success'], code: "1" };
                                                            // validate_header.encryptionPlain(response_data, function (responseData) {
                                                            // sock.to(users[item.user_id]['socket']).emit('send_message', response_data);
                                                            console.log(item.user_id)
                                                            sock.to(users[item.user_id]['socket']).emit('receive_message', response_data);
                                                            console.log("response_data ++++==============", response_data);
                                                            next();
                                                            // });
                                                        } else {
                                                            /* send notification */
                                                            console.log("response_data====receive_message==========", response_data);
                                                            var insert_data = {
                                                                emit_type: 'receive_message',
                                                                emit_to: item.user_id,
                                                                emit_response: JSON.stringify(response_data)
                                                            }
                                                            chat_model.store_emit(insert_data, (result) => {
                                                                next();
                                                            })
                                                        }
                                                    })
                                                })
                                            } else {
                                                chat_model.get_unread_count({ chat_room_id: result.chat_room_id, user_id: item.user_id }, (count) => {
                                                    response_data.data.unread_count = count;
                                                    if (users[item.user_id] != undefined) {
                                                        console.log("response_data222==============", response_data);
                                                        console.log(item.user_id)
                                                        sock.to(users[item.user_id]['socket']).emit('receive_message', response_data);
                                                        next();
                                                        // });
                                                    } else {
                                                        /* send notification */
                                                        console.log("response_data222====receive_message==========", response_data);
                                                        var insert_data = {
                                                            emit_type: 'receive_message',
                                                            emit_to: item.user_id,
                                                            emit_response: JSON.stringify(response_data)
                                                        }
                                                        chat_model.store_emit(insert_data, (result) => {
                                                            next();
                                                        })
                                                    }
                                                })
                                            }
                                        })
                                    }, () => {
                                        console.log('Loop Is Completed')
                                        console.log('User id: ' + request.sender_id + ' =>', users)
                                        console.log('User is now connected: ', users[request.sender_id])
                                        response_data.message = t('rest_keyword_send_msg_success')
                                        if (users[request.sender_id] != undefined) {
                                            sock.to(users[request.sender_id]['socket']).emit('send_message', response_data);
                                        } else {
                                            var insert_data = {
                                                emit_type: 'send_message',
                                                emit_to: request.sender_id,
                                                emit_response: JSON.stringify(response_data)
                                            }
                                            chat_model.store_emit(insert_data, (result) => {
                                            })
                                        }
                                    })
                                } else {
                                    console.log("receivers not found")
                                    response_data.message = t('rest_keyword_send_msg_success')
                                    sock.to(users[request.sender_id]['socket']).emit('send_message', response_data);
                                }
                            } else {
                                var response_data = { code: responseCode.FAILED, message: t('rest_keyword_chat_room_invalid'), data: {} };

                                sock.to(users[request.sender_id]['socket']).emit('send_message', response_data);
                            }
                        } else {
                            var response_data = { code: responseCode.FAILED, message: message, data: {} };

                            sock.to(users[request.sender_id]['socket']).emit('block_word', response_data);

                        }
                    });
                });
                socket.on('read_message', function (req) {
                    // console.log("req+++++++++++++++++")
                    // console.log(req)
                    // validate_header.dcryption(req, function (request) {
                    // console.log("users[request.receiver_id]");
                    chat_model.read_meesage(req, (code, message, data) => {
                        if (code == 1 || code == '1') {
                            if (data.length > 0) {
                                asyncLoop(data, (item, next) => {
                                    var response_data = { code: responseCode.SUCCESS, message: t('rest_keyword_message_read_success'), data: { message_id: item.message_id, is_read: 1 } };
                                    if (users[item.sender_id] != undefined) {
                                        sock.to(users[item.sender_id]['socket']).emit('read_message', response_data);
                                    } else {
                                        var insert_data = {
                                            emit_type: 'read_message',
                                            emit_to: item.sender_id,
                                            emit_response: JSON.stringify(response_data)
                                        }
                                        chat_model.store_emit(insert_data, (result) => {
                                        })
                                    }
                                    next();
                                })
                            } else {

                            }

                        } else {
                            req.is_read = 0
                            var response_data = { code: responseCode.SUCCESS, message: t('rest_keyword_message_went_wrong'), data: req };
                            if (users[user_id] != undefined) {
                                sock.to(users[user_id]['socket']).emit('read_message', response_data);
                            }
                            console.log("read_message----", message)
                        }
                    })
                    // });
                });
                socket.on('send_amount', function (req) {
                    user_model.send_amount(req, (code, message, data) => {
                        if (code == 1 || code == '1') {
                            if (data.length > 0) {
                                asyncLoop(data, (item, next) => {
                                    var response_data = { code: responseCode.SUCCESS, message: t('rest_keyword_message_read_success'), data: { message_id: item.message_id, is_read: 1 } };
                                    if (users[item.sender_id] != undefined) {
                                        sock.to(users[item.sender_id]['socket']).emit('read_message', response_data);
                                    } else {
                                        var insert_data = {
                                            emit_type: 'read_message',
                                            emit_to: item.sender_id,
                                            emit_response: JSON.stringify(response_data)
                                        }
                                        chat_model.store_emit(insert_data, (result) => {
                                        })
                                    }
                                    next();
                                })
                            } else {

                            }

                        } else {
                            req.is_read = 0
                            var response_data = { code: responseCode.SUCCESS, message: t('rest_keyword_message_went_wrong'), data: req };
                            if (users[user_id] != undefined) {
                                sock.to(users[user_id]['socket']).emit('read_message', response_data);
                            }
                            console.log("read_message----", message)
                        }
                    })
                    // });
                });
                socket.on('decline_request', function (req) {
                    chat_model.decline_request(req, (code, message, resp_data) => {
                        var response_data = resp_data;
                        if (code == 1 || code == '1') {
                            if (resp_data.user_details.length > 0) {
                                asyncLoop(resp_data.user_details, (item, next) => {
                                    console.log("decline_request", item);
                                    if (users[item.user_id] != undefined) {
                                        delete response_data['user_details'];
                                        sock.to(users[item.user_id]['socket']).emit('decline_request', response_data);
                                    } else {
                                        // delete response_data['user_details'];
                                        var insert_data = {
                                            emit_type: 'decline_request',
                                            emit_to: item.user_id,
                                            emit_response: JSON.stringify(response_data)
                                        }
                                        chat_model.store_emit(insert_data, (result) => {
                                        })
                                    }
                                    next();
                                }, () => {
                                    // delete response_data['user_details'];
                                    if (users[resp_data.sender_id] != undefined) {
                                        sock.to(users[resp_data.sender_id]['socket']).emit('decline_request', response_data);
                                    } else {
                                        var insert_data = {
                                            emit_type: 'decline_request',
                                            emit_to: resp_data.sender_id,
                                            emit_response: JSON.stringify(response_data)
                                        }
                                        chat_model.store_emit(insert_data, (result) => {
                                        })
                                    }
                                })
                            } else {
                                // delete response_data['user_details'];
                                if (users[resp_data.sender_id] != undefined) {
                                    sock.to(users[resp_data.sender_id]['socket']).emit('decline_request', response_data);
                                } else {
                                    var insert_data = {
                                        emit_type: 'decline_request',
                                        emit_to: resp_data.sender_id,
                                        emit_response: JSON.stringify(response_data)
                                    }
                                    chat_model.store_emit(insert_data, (result) => {
                                    })
                                }
                            }
                        } else {
                            // delete response_data['user_details'];
                            if (users[req.user_id] != undefined) {
                                sock.to(users[req.user_id]['socket']).emit('decline_request', response_data);
                            } else {
                                var insert_data = {
                                    emit_type: 'decline_request',
                                    emit_to: req.user_id,
                                    emit_response: JSON.stringify(response_data)
                                }
                                chat_model.store_emit(insert_data, (result) => {
                                })
                            }
                        }
                    })
                });
                socket.on('delete_message', function (req) {
                    console.log("delete_message+++++++++++++++++")
                    console.log(req)
                    req.user_id = user_id;
                    // validate_header.dcryption(req, function (request) {
                    // console.log("users[request.receiver_id]");
                    chat_model.delete_message(req, (code, data) => {
                        if (code) {
                            asyncLoop(data, (item, next) => {
                                var response_data = { code: responseCode.SUCCESS, message: t('rest_keyword_message_delete_success'), data: req };
                                if (users[item.user_id] != undefined) {
                                    sock.to(users[item.user_id]['socket']).emit('delete_message', response_data);
                                } else {
                                    var insert_data = {
                                        emit_type: 'delete_message',
                                        emit_to: item.user_id,
                                        emit_response: JSON.stringify(response_data)
                                    }
                                    chat_model.store_emit(insert_data, (result) => {
                                    })
                                }
                                next();
                            })

                        } else {
                            var response_data = {
                                code: responseCode.SUCCESS, message: t('rest_keyword_message_went_wrong'), data: {}
                            };
                            if (users[user_id] != undefined) {
                                sock.to(users[user_id]['socket']).emit('delete_message', response_data);
                            }
                            console.log("delete_message----", data)
                        }
                    })
                    // });
                });
                socket.on('end_stream', function (req) {
                    console.log("end_stream+++++++++++++++++")
                    req.user_id = user_id;
                    console.log(req)
                    console.log("end_stream ,", users[user_id])

                    live_stream_model.end_stream(req, (code, msg, data) => {
                        var response_data = { code: code, message: msg, data: data };
                        sock.to(users[user_id]['socket']).emit('end_stream', response_data);
                    });
                });
                socket.on('disconnect', function () {
                    for (var user_id in users) {
                        if (users[user_id].socket === socket.id) {
                            console.log(user_id + " is disconnect");
                            var params =
                            {
                                chat_status: "offline"
                            }
                            con.query("UPDATE tbl_users SET ? WHERE id = '" + user_id + "'", params, function (err, result, fields) {

                            });

                            //code for sending offline user
                            var response = { code: responseCode.SUCCESS, message: t('rest_keyword_message_user_offline'), data: { user_id: user_id, user_type: user_type, chat_status: 'offline' } };

                            // validate_header.encryptionPlain(response, function (responseData) {
                            // sock.to(users[user_id]['socket']).emit('disconnect', response);
                            // socket.broadcast.emit('live', response);

                            // });
                            delete users[user_id];
                            delete global._unic_sokect_user[user_id];

                            break;
                        }
                    }
                });
            });

        global._unic_sokect_ = sock;
        console.log("users", global._unic_sokect_user)
    }
}

module.exports = socket_model